#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m07__Logické_operace.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
7  Logické hodnoty a operace

Co se v kapitole naučíte
Tato kapitola se soustřeďuje na výklad práce s logickými hodnotami.
Vysvětlí základní pravidla, která umožňují chápat jakoukoliv hodnotu
jako logickou, a naučí vás pracovat s operátory,
jejichž operandy a/nebo výsledek jsou logické hodnoty. V závěru probere
možnosti práce s jednotlivými bity celých čísel a naučí vás používat
podmíněný výraz, jehož hodnota závisí na splnění zadané podmínky.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 7.1:	Převody logických hodnot na čísla a jiných hodnot na logické
###########################################################################q
5 > 3     # 5 je opravdu věští než 3
# True
3 > 5     # Není pravda, že 3 je větší než 5
# False
False + True  # V případě potřeby se logické konstanty převedou na čísla
# 1
0 + True      # Hodnota konstanty True je 1
# 1
0 + False     # Hodnota konstanty False je 0
# 0
bool(None), bool(0), bool(0.0), bool(0J), bool("")
# (False, False, False, False, False)
bool(123), bool(3.14), bool(1J), bool('False'), bool(...), bool(NotImplemented)
# (True, True, True, True, True, True)
# >>>



#Výpis 7.2:	Zřetězené porovnávání
###########################################################################q
1 < 3 < 33 < 99
# True
1 < 3 == 3 > 2
# True
1 < 3 > 33 > 22
# False
low=10;   high=33;   val=20
0 < low <= val <= high < 100
# True
# >>>



#Výpis 7.3:	Test totožnosti objektů
###########################################################################q
a = "Ahoj "
b = "světe"
ab = a + b
ab == (a + b)
# True
ab is (a + b),   id(ab),   id(a+b)
# (False, 2217402464272, 2217402948976)
# >>>



#Výpis 7.4:	Chování logických operátorů
###########################################################################q
a = 5 > 3         # Výsledek porovnání (logická hodnota) ukládám do proměnné
a
# True
not a
# False
'' and 'cokoliv'  # Levý operand je False => jeho hodnota je výsledkem
# ''
1 and ''          # Levý operand je True => výsledkem je hodnota pravého
# ''
'' or 'cokoliv'   # Levý operand je False => výsledkem je hodnota pravého
# 'cokoliv'
1 or ''           # Levý operand je True => jeho hodnota je výsledkem
# 1
not a or 0 or "" or "poslední" # První tři jsou False => výsledkem je hodnota posledního
# 'poslední'
not a or 9 or "" or "poslední" # Druhý je True, výsledek je jeho hodnota
# 9
# >>>



#Výpis 7.5:	Vliv priorit na výsledek
###########################################################################q
print(f'a = {(a:=1)},   b = {(b:=2)}\n{ (not  a == b)  = }\n'
      f'{ (not (a == b)) = }\n{((not a) == b)  = }')
# a = 1,   b = 2
#  (not  a == b)  = True
#  (not (a == b)) = True
# ((not a) == b)  = False
#!# a == not b
# SyntaxError: invalid syntax
a == (not b)
# False
# >>>



#Výpis 7.6:	Chování bitových operátorů
###########################################################################q
bin(0b1100 & 0b1010)   #AND: 1 pouze tehdy, jsou-li oba bity 1
# '0b1000'
bin(0b1100 | 0b1010)   #OR:  0 pouze tehdy, jsou-li oba bity 0
# '0b1110'
bin(0b1100 ^ 0b1010)   #XOR: 1 právě tehdy, jsou li bity různé
# '0b110'
bin(~0b0101)
# '-0b110'
bin(~0b0101 & 0b1111)
# '0b1010'
# >>>



#Výpis 7.7:	Bitové posuny
###########################################################################q
bin(0b101001000 >> 3)   # Posun doprava o 3 bity
# '0b101001'
0b101    # Binárně 5
# 5
5 << 3   # Posun doleva o 3 bity je ekvivalentní násobení 2**3 = 8
# 40
bin(40)  # Zobrazíme výsledek ve dvojkové soustavě
# '0b101000'
bin(-64), bin(-64 & 0xFFFF)  # Zobrazení čísla bez znaménka
# ('-0b1000000', '0b1111111111000000')
(x:=-64 >> 3),  bin(x & 0xFFFF)
# (-8, '0b1111111111111000')
# >>>



#Výpis 7.8:	Použití podmíněného výrazu
###########################################################################q
pm = lambda x : ('plus ' if x>=0 else 'mínus ') + str(abs(x))
pm(5), pm(-5)
# ('plus 5', 'mínus 5')
pm = lambda x : 'plus ' if x>=0 else 'mínus ' + str(abs(x))
pm(5), pm(-5)
# ('plus ', 'mínus 5')
sign = lambda x : -1 if x<0 else 0 if x==0 else +1
sign(-10), sign(0), sign(+5)
# (-1, 0, 1)
# >>>



#Výpis 7.0: Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
