#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m12__Parametry_argumenty.py
"""
Příkazy zadávané ve výpisech kapitoly:
12  Parametry, argumenty a lokální proměnné funkcí
"""
import dbg; dbg.start_mod(1, __name__)
###########################################################################q



#Výpis 12.1:	Definice a volání funkce s parametrem
###########################################################################q
def dhb(n):
    """Vytiskne zadané číslo v soustavách o základu 10, 16 a 2."""
    print(n, hex(n), bin(n))

dhb(999)
# 999 0x3e7 0b1111100111
# >>>



#Výpis 12.2:	Definice funkce s lokálními proměnnými
###########################################################################q
def objemVálce(průměr, výška):
    """Vytiskne objem válce o zadaném průměru a výšce."""
    základna = 3.1415926 * průměr * průměr / 4
    objem    = základna * výška
    print(f'Objem válce o průměru {průměr} a výšce {výška} je {objem}')

# >>>



#Výpis 12.3:	Volání funkcí s parametry
###########################################################################q
objemVálce(1, 2)   # Při zadávání argumentů musím dodržet pořadí
# Objem válce o průměru 1 a výšce 2 je 1.5707963
objemVálce(výška=2, průměr=1)   # Nebo je zadávat pojmenované
# Objem válce o průměru 1 a výšce 2 je 1.5707963
#!# objemVálce(průměr=1, 2)         # Musí se začít pozičními
# SyntaxError: positional argument follows keyword argument
objemVálce(1, výška=2)
# Objem válce o průměru 1 a výšce 2 je 1.5707963
objemVálce(2, průměr=1)         # Poziční nelze přeskakovat
# Traceback (most recent call last):
#   File "<pyshell#23>", line 1, in <module>
#     objemVálce(2, průměr=1)
# TypeError: objemVálce() got multiple values for argument 'průměr'
def posKeyDemo(p1, p2, p3, p4, p5):
    """Pomocná funkce pro demonstraci práce s pozičními parametry."""
    print(f'{p1=}, {p2=}, {p3=}, {p4=}, {p5=}')

posKeyDemo('a1', 'a2', 'a3', 'a4', 'a5', )
# p1='a1', p2='a2', p3='a3', p4='a4', p5='a5'
posKeyDemo(10, 20, p5=55, p3=33, p4=44)
# p1=10, p2=20, p3=33, p4=44, p5=55
# >>>



#Výpis 12.4:	Funkce s povinně pojmenovanými argumenty
###########################################################################q
def rozměr(název, *, délka, šířka, výška):
    """Vytiskne zadaný název a rozměry objektu. Ukázka funkce,
    jejíž některé argumenty jsou povinně zadávány jako pojmenované.
    """
    print(f'{název}: {délka=}, {šířka=}, {výška=}')

rozměr('stůl', výška=75, délka=120, šířka=60)
# stůl: délka=120, šířka=60, výška=75
rozměr('deska', 100, 50, 2)
# Traceback (most recent call last):
#   File "<pyshell#35>", line 1, in <module>
#     rozměr('deska', 100, 50, 2)
# TypeError: rozměr() takes 1 positional argument but 4 were given
# >>>



#Výpis 12.5:	Funkce s povinně pozičními argumenty
###########################################################################q
def positional(p1, p2, /, p3):
    """Funkce, jejíž první dva argumenty musí být zadány jako poziční."""
    print(f'{p1=}, {p2=}, {p3=}')

positional(1, 2, 3)
# p1=1, p2=2, p3=3
positional(11, 22, p3=33)
# p1=11, p2=22, p3=33
positional(111, p2=222, p3=333)
# Traceback (most recent call last):
#   File "<pyshell#28>", line 1, in <module>
#     positional(111, p2=222, p3=333)
# TypeError: positional() got some positional-only arguments passed as keyword arguments: 'p2'
# >>>



#Výpis 12.6:	Funkce s různými kombinacemi povinných parametrů
###########################################################################q
def fpp (p1, p2, p3, p4, /):
    """Funkce deklarující pouze poziční parametry."""
    print(f"{p1=} # {p2=} # {p3=} # {p4=}")

fpp(10, 20, 30, 40)
# p1=10 # p2=20 # p3=30 # p4=40
def fnn (*, n1, n2, n3, n4):
    """Funkce deklarující pouze pojmenované parametry."""
    print(f"{n1=} # {n2=} # {n3=} # {n4=}")

fnn(n1=100, n2=200, n3=300, n4=400)
# n1=100 # n2=200 # n3=300 # n4=400
def fpn (p1, p2, /, *, n1, n2):
    """Funkce deklarující dva jen poziční a dva jen pojmenované parametry."""
    print(f"{p1=} # {p2=} # {n1=} # {n2=}")

fpn(1, 2, n1=101, n2=202)
# p1=1 # p2=2 # n1=101 # n2=202
def fpgn (p1, p2, /, g1, g2, *, n1, n2):
    """Funkce požadující všechny tři druhy argumentů:
    dva jen poziční, dva obecné a dva jen pojmenované.
    """
    print(f"{p1=} # {p2=} # {g1=} # {g2=} # {n1=} # {n2=}")

fpgn(1, 2, 10, 20, n1=110, n2=220)
# p1=1 # p2=2 # g1=10 # g2=20 # n1=110 # n2=220
fpgn(1, 2, 10, g2=21, n1=111, n2=221)
# p1=1 # p2=2 # g1=10 # g2=21 # n1=111 # n2=221
fpgn(1, 2, g1=12, g2=22, n1=112, n2=222)
# p1=1 # p2=2 # g1=12 # g2=22 # n1=112 # n2=222
# >>>



#Výpis 12.7:	Volání funkce print() s vlastní hodnotou implicitního argumentu
###########################################################################q
def dhb(n):
    """Vytiskne zadané číslo v soustavách o základu 10, 16 a 2."""
    print(n, hex(n), bin(n), sep=' = ')

dhb(999)
# 999 = 0x3e7 = 0b1111100111
# >>>



#Výpis 12.8:	Definice funkce se dvěma implicitními argumenty
#               a možnosti jejího volání
###########################################################################q
def kruh(x, y, r=1, barva="černá"):
    """Ukázka funkce se dvěma implicitními argumenty."""
    print(f"{x=}, {y=}, {r=}, {barva=!s}")

kruh(10, 20)
# x=10, y=20, r=1, barva=černá
kruh(11, 22, 33)
# x=11, y=22, r=33, barva=černá
kruh(1, 2, 3, 'modrá')
# x=1, y=2, r=3, barva=modrá
kruh(1.5, 2.7, barva='žlutá')
# x=1.5, y=2.7, r=1, barva=žlutá
# >>>



#Výpis 12.9:	Konstantnost předdefinovaných hodnot
###########################################################################q
a = 1
def default(x = a): print('Hodnota x =', x)

default()
# Hodnota x = 1
a = 7
default()
# Hodnota x = 1
default(5)
# Hodnota x = 5
# >>>



#Výpis 12.10:	Funkce s vedlejším efektem
###########################################################################q
print('"Vrátí" nic:', kruh(10, 20))   #Vedlejší efekt
# x=10, y=20, r=1, barva=černá
# "Vrátí" nic: None
# >>>



#Výpis 12.11:	Definice a použití funkcí vracejících hodnotu
###########################################################################q
def fahr2cel(fahr):
    """Převede stupně Fahrenheita na stupně Celsia."""
    return 5 / 9 * (fahr - 32)

def fahr2celsLV(fahr):
    """Stejná funkcionalita, používá lokální proměnné."""
    from0 = fahr - 32
    koef  = 5/9
    cels  = koef * from0
    return cels

print('Papír hoří při', round(fahr2cel(451)), '\N{DEGREE CELSIUS}')
# Papír hoří při 233 ℃
# >>>



#Výpis 12.12:	Nepoužitelnost přetěžování funkcí
###########################################################################q
def a(): pass

def a(b): pass

a()
# Traceback (most recent call last):
#   File "<pyshell#211>", line 1, in <module>
#     a()
# TypeError: a() missing 1 required positional argument: 'b'
def krát(x, y) : return x * y

krát(3, 4);  krát(3, 'Čtyři')
# 12
# 'ČtyřiČtyřiČtyři'
# >>>



#Výpis 12.13:	Deklarace typů proměnných a návratových hodnot
#               prostřednictvím anotací
###########################################################################q
atr:int     # Proměnnou můžeme anotovat i bez inicializace
def fce(text:str, x:int=0) -> None:
    """Definice funkce se dvěma parametry, která nic nevrací."""
    print(f'{text=}, {x=}')

atr = 'Atribut'     # Dodržení deklarovaných typů není kontrolováno
fce(12345, atr)
# text=12345, x='Atribut'
# >>>



#Výpis 12.14:	Definice modulu m11b_dbg_demo
###########################################################################q

""" Je uloženo v souboru
m12a_dbg_demo.py
"""



#Výpis 12.15:	Import modulu m11b_dbg_demo a zavolání jeho funkce fce1()
###########################################################################q
import m11b_dbg_demo as m
m.fce1()



#Výpis 12.0:	Popisek
###########################################################################q
"""
Je uloženo v souboru
#R:/71_INP/xxx.py
"""
##### Kapitola 12.0:	Název
#--------------------------------------------------------------------------q
                                                                       #SYNC
###########################################################################q
dbg.stop_mod(1, __name__)
