#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m16__Ošetřování_chyb.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
16  Ošetřování chyb.

Co se v kapitole naučíte
Tato kapitola vám vysvětli princip reakce na běhové chyby prostřednictvím
vyvolávání, resp. vyhazování výjimek a jejich následného zachytávání.
Probere složený příkaz try s jeho větvemi except, else a finally.
Poté vysvětlí, jak výjimku vytvořit a následně vyhodit.
Na závěr ještě jednou probere příkaz assert.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 16.1:	Ukázky syntaktických chyb a reakcí na ně při zadávání příkazů
#               v prostředí IDLE
###########################################################################q
#!# text = "První" +   # Předčasné ukončení řádku



#Výpis 16.2:	Ukázky syntaktických chyb a reakcí na ně při zadávání
#               příkazů z konzolového okna
###########################################################################q
#!# def err_demo():
#!#     """Funkce obsahující syntaktickou chybu."""
#!#     while True print('Hello world')

import m16a_Chyby



#Výpis 16.3:	Zopakovaný výpis 10.5 ze strany 158 zobrazující načtení
#               třetí verze modulu m10a_Modul z výpisu 10.1 na straně 148
###########################################################################q
import m10a_Modul as m              # SYNC
from importlib import reload        # SYNC
reload(m)



#Výpis 16.4:	Ukázka zachycení a ošetření výjimky
###########################################################################q
def input_int() -> int:
    """Vrátí celé číslo zadané uživatelem z klávesnice.
       Základní podoba příkazu s větví try a jednou větví except.
    """
    while ...:
        try:
            x = int(input('Zadejte celé číslo: '))
            break   # Korektní zadání, můžeme cyklus ukončit
        except ValueError:
            print('To nebylo platné celé číslo! Zkuste to znovu...')
    return x
                                                                     #SYNC
print('\nZadali jste číslo:', input_int())



#Výpis 16.5:	AHA-příklad používající příkaz try se všemi dostupnými větvemi
###########################################################################q
def input_int_full_try() -> int:
    """Vrátí celé číslo zadané uživatelem z klávesnice.
       Hlavním účelem je demonstrovat úplnou podobu příkazu
       a funkci jednotlivých větví při vyhození a nevyhození výjimky.
    """
    entered = False      # Ještě nebylo zadáno
    while not entered:   # Dokud nebude korektně zadáno
        try:
            x = int(input('----------------------\nZadejte celé číslo: '))
            print('++ Zadáno')
            entered = True    # Aby se cyklus ukončil
        except ValueError:
            print('-- To nebylo platné celé číslo! Zkuste to znovu...')
        else:
            print('ee Prochází se větev else')
        finally:
            print('ff Prochází se větev finally')
        print('cc Pokračujeme v těle cyklu - opakovat =', not entered)
    print('zz Cyklus ukončen, vrátili jsme se do těla funkce')
    return x
                                                                     #SYNC
print('\nZadali jste číslo:', input_int_full_try())



#Výpis 16.6:	Měření rychlosti počítače a přesnosti odhadu času
###########################################################################q
def kbd(times):
    """Umožňuje měřit přesnost uživatele při odhadu času
       a jako vedlejší efekt měří rychlost počítače.
    """
    from time import time
    for p in range(0, times):
        t1 = time()
        try:
            n = 0
            while True: n += 1
        except KeyboardInterrupt:
            t2 = time()
            print(p, '. pokus, ', n, ' běhů, ', s:=round(t2-t1, 3), ' sekund, ',
                  round(n/s/1e6, 3), ' běhů za mikrosekundu', sep='')
    print('Konec testu')

kbd(3)



#Výpis 16.7:	Záludnosti větve finally
###########################################################################q
def demo_finally(arg) -> str:
    """Metoda demonstruje, chování bloku finally
    v některých nestandardních situacích.
    """
    sum = f'demo({arg}): '
    def add(a): nonlocal sum; sum += f'({a}) '
    try:
        if   arg > 0: add('run'); return sum
        elif arg < 0: add('exc'); raise Exception(sum)
    except Exception as ex:
        add('In exc')
        raise ex
    finally:
        add('In fin')
        if arg in (-1, 1):
            add('From fin')
            return sum
    return (f'Outside: {sum}')

for i in range(2, -3, -1): print(demo_finally(i))



#Výpis 16.8:	Funkce assert_stmt() demonstrující funkci příkazu assert
###########################################################################q
def assert_stmt(test, info=''):
    if __debug__:
        if not test:
            raise AssertionError(info)



#Výpis 16.9:	Přidání poznámky k zachycené výjimce
###########################################################################q
def power_sequence(a):
    a = float(a)
    try:
        while True:
            print(f'{(a := a ** a)}')
    except Exception as e:
        e.add_note(f'Výjimka vyhozena při {a=}')
        raise e

power_sequence(2)



#Výpis 16.Y:	Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
