#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m18__Ntice.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
18  N-tice.

Co se v kapitole naučíte
Tato kapitola vás seznámí s n-ticemi, které bychom mohli chápat jako
neměnné seznamy. Nejprve vysvětlí, jak je možné n-tici vytvořit,
poté probere generátorovou notaci, možnosti přístupu k jednotlivým prvkům
a hlouběji rozebere problematiku neměnnosti.
Na závěr pak představí možnosti sčítání seznamů a n tic.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 18.1:	Vytváření n-tic pomocí literálů
###########################################################################q
x, y, z = 10, 20, 30
x, y, z
# (10, 20, 30)
t3 = 11, 22, 33;    t3
# (11, 22, 33)
(t3 := 11, 22, 33);   f'{t3=}'   # Význam: ((t3 := 11), 22, 33)
# (11, 22, 33)
# 't3=11'
(t3 := (11, 22, 33) );   f'{t3=}'
# (11, 22, 33)
# 't3=(11, 22, 33)'
t0 = ()
t1 = 101, ;   t1
# (101,)
t1 = (111,);   t1
# (111,)
t2 = ('Raz', 'Dva',)
(t4 := (t0, t1, t2, t3))
# ((), (111,), ('Raz', 'Dva'), (11, 22, 33))
# >>>



#Výpis 18.2:	Vytváření n-tic pomocí funkce tuple()
###########################################################################q
tuple('Python')
# ('P', 'y', 't', 'h', 'o', 'n')
tuple(range(5))
# (0, 1, 2, 3, 4)
tuple([10,20,30])
# (10, 20, 30)
tuple()
# ()
# >>>



#Výpis 18.3:	Vytváření n-tic z jiných n tic pomocí sčítání a násobení
###########################################################################q
t4;  t0 + t1 + t2 + t3 + (('a', 2), list('nic'))
# ((), (111,), ('Raz', 'Dva'), (11, 22, 33))
# (111, 'Raz', 'Dva', 11, 22, 33, ('a', 2), ['n', 'i', 'c'])
t23 = t2 * 3;   t23
# ('Raz', 'Dva', 'Raz', 'Dva', 'Raz', 'Dva')
t1 + [222, 333]
# Traceback (most recent call last):
#   File "<pyshell#34>", line 1, in <module>
#     t1 + [222, 333]
# TypeError: can only concatenate tuple (not "list") to tuple
t1 + tuple([222, 333])
# (111, 222, 333)
# >>>



#Výpis 18.4:	Vytváření n-tic přičítáním
###########################################################################q
tpl = (1, 2);   (tpl1 := tpl)
# (1, 2)
tpl += (3, 4);   f'{tpl = },    {tpl1 = }'
# 'tpl = (1, 2, 3, 4),    tpl1 = (1, 2)'
# >>>



#Výpis 18.5:	Balení a rozbalování n-tic a seznamů
###########################################################################q
(raz, dva, tři) = (1, 2, 3)
print(f'{raz=}, {dva=}, {tři=}')
# raz=1, dva=2, tři=3
one, two, three = 11, 22, 33
print(f'{one=}, {two=}, {three=} ')
# one=11, two=22, three=33
[a, b] = [11, 22]
[c, d] = 33, 43
[e, f] = (55, 66)
(g, h) = 77, 88
i, j = [99, 111]
k, l = (222, 333)
a, b, c, d, e, f, g, h, i, j, k, l
# (11, 22, 33, 43, 55, 66, 77, 88, 99, 111, 222, 333)
# >>>



#Výpis 18.6:	Prohazování hodnot proměnných
###########################################################################q
t0, t1, t2
# ((), (111,), ('Raz', 'Dva'))
tpom = t0;   t0 = t1;   t1 = t2;   t2 = tpom
print(f'{t0=}, {t1=}, {t2=}')
# t0=(111,), t1=('Raz', 'Dva'), t2=()
t0, t1, t2 = t2, t0, t1
print(f'{t0=}, {t1=}, {t2=}')
# t0=(), t1=(111,), t2=('Raz', 'Dva')
# >>>



#Výpis 18.7:	Hvězdičkové pravidlo
###########################################################################q
x = (1, 2, 3, 4)
a, b, *c = x;   a, b, c
# (1, 2, [3, 4])
a, *b, c = x;   a, b, c
# (1, [2, 3], 4)
*a, b, c = x;   a, b, c
# ([1, 2], 3, 4)
a, b, c, d, *e = x;   a, b, c, d, e
# (1, 2, 3, 4, [])
# >>>



#Výpis 18.8:	Vytvoření n tice pomocí generátoru
###########################################################################q
gen = (x*x for x in range(3, 30, 3));   gen
# <generator object <genexpr> at 0x0000028AE118B890>
tuple(gen)
# (9, 36, 81, 144, 225, 324, 441, 576, 729)
tuple(x for x in range(3, 30, 3) if x&1 != 0)
# (3, 9, 15, 21, 27)
tuple((a,n) for a in 'abc' for n in (0,1))
# (('a', 0), ('a', 1), ('b', 0), ('b', 1), ('c', 0), ('c', 1))
# >>>



#Výpis 18.9:	Přístup k prvkům n tic
###########################################################################q
tpl = ([1,2,3], [10,20,30])
tpl[1][1] = 22;   tpl
# ([1, 2, 3], [10, 22, 30])
tpl[1] = [11, 22, 33]
# Traceback (most recent call last):
#   File "<pyshell#2>", line 1, in <module>
#     tpl[1] = [11, 22, 33]
# TypeError: 'tuple' object does not support item assignment
# >>>



#Výpis 18.10:	Chování n tic s proměnnými a neměnnými prvky
###########################################################################q
tpl = a, b, c = ('aa',), ('bb',), ('cc',);   tpl, c; \
c  += ('CC',);                               tpl, c
# ((('aa',), ('bb',), ('cc',)), ('cc',))
# ((('aa',), ('bb',), ('cc',)), ('cc', 'CC'))
tpl = a, b, c = ['aa',], ['bb',], ['cc',];   tpl, c; \
c  += ['CC'];                                tpl, c
# ((['aa'], ['bb'], ['cc']), ['cc'])
# ((['aa'], ['bb'], ['cc', 'CC']), ['cc', 'CC'])
# >>>



#Výpis 18.11:	Sčítání seznamů a n-tic
###########################################################################q
lst = [1, 2];   tpl = ('a', 'b')
lst + tpl       # Přičítám n-tici k seznamu
# Traceback (most recent call last):
#   File "<pyshell#8>", line 1, in <module>
#     lst + tpl       # Přičítám n-tici k seznamu
# TypeError: can only concatenate list (not "tuple") to list
tpl + lst       # Přičítám seznam k n-tici
# Traceback (most recent call last):
#   File "<pyshell#9>", line 1, in <module>
#     tpl + lst       # Přičítám seznam k n-tici
# TypeError: can only concatenate tuple (not "list") to tuple
lst + list(tpl)    # N-tici převedu na seznam => výsledkem bude seznam
# [1, 2, 'a', 'b']
tuple(lst) + tpl   # Seznam převedu na n-tici => výsledkem bude n-tice
# (1, 2, 'a', 'b')
# >>>



#Výpis 18.12:	Prvky standardních n-tic nemají jména
###########################################################################q
def pxyz(): print(f'{xyz=}, {x=}, {y=}, {z=}')

xyz = (x, y, z) = 10, 20, 30;   pxyz()
# xyz=(10, 20, 30), x=10, y=20, z=30
x+=1; y+=2; z+=3;    pxyz()
# xyz=(10, 20, 30), x=11, y=22, z=33
xyz.x
# Traceback (most recent call last):
#   File "<pyshell#12>", line 1, in <module>
#     xyz.x
# AttributeError: 'tuple' object has no attribute 'x'
# >>>



#Výpis 18.13:	Pojmenované n-tice
###########################################################################q
from collections import namedtuple
Xyz = namedtuple('XYZ', 'x y z')
t1 = Xyz(1, 2, 3);      t1
# XYZ(x=1, y=2, z=3)
type(t1)
# <class '__main__.XYZ'>
t2 = Xyz(11, z=33, y=22);   t2
# XYZ(x=11, y=22, z=33)
t1.x + t2.y,   t1[1] + t2[2]
# (23, 35)
t1.x = 0
# Traceback (most recent call last):
#   File "<pyshell#22>", line 1, in <module>
#     t1.x = 0
# AttributeError: can't set attribute
# >>>



#Výpis 18.14:	Pojmenované n tice s implicitními argumenty
###########################################################################q
Abcd = namedtuple('Abcd', ['a', 'b', 'c', 'd'], defaults=[33, 44])
Abcd(1, 2)
# Abcd(a=1, b=2, c=33, d=44)
Abcd(1, 2, 3)
# Abcd(a=1, b=2, c=3, d=44)
Abcd(1, 2, 3, 4)
# Abcd(a=1, b=2, c=3, d=4)
# >>>



#Výpis 18.0:	Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
