#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m19__Množiny.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
19  Množiny.

Co se v kapitole naučíte
Tato kapitola představí třídu set, jejíž instance reprezentují množiny.
Po základním seznámení vás naučí množiny vytvářet, a to včetně využití
jejich generátorové notace. Poté probere jejich speciální druh,
tzv. zmrazené množiny – instance třídy frozenset, a vysvětlí vám,
k čemu se používají. Na závěr předvede množinové operace.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 19.1:	Vytváření množin pomocí literálů
###########################################################################q
s = {1, 'a', 1+1j, (min, max)};   s;   type(s)
# {'a', 1, (1+1j), (<built-in function min>, <built-in function max>)}
# <class 'set'>
{1, 'a', 1+1j, [min, max]}
# Traceback (most recent call last):
#   File "<pyshell#122>", line 1, in <module>
#     {1, 'a', 1+1j, [min, max]}
# TypeError: unhashable type: 'list'
s0 = {};   type(s0)
# <class 'dict'>
# >>>



#Výpis 19.2:	Vytváření množin pomocí funkce set()
###########################################################################q
s0 = set();   print(s0, type(s0))
# set() <class 'set'>
set('Python')
# {'y', 'o', 't', 'h', 'P', 'n'}
for c in set('Python'): print(c, hash(c)%32, sep=':', end=' ')

# y:2 o:6 t:16 h:18 P:20 n:30
# >>>



#Výpis 19.3:	Povolené a nepovolené argumenty konstruktoru set()
###########################################################################q
set((1,2,3,4,5))
# {1, 2, 3, 4, 5}
set(1,2,3,4,5)
# Traceback (most recent call last):
#   File "<pyshell#2>", line 1, in <module>
#     set(1,2,3,4,5)
# TypeError: set expected at most 1 argument, got 5
set(1)
# Traceback (most recent call last):
#   File "<pyshell#3>", line 1, in <module>
#     set(1,)
# TypeError: 'int' object is not iterable
set((1,))
# {1}
# >>>



#Výpis 19.4:	Vytváření množin prostřednictvím množinových operací
###########################################################################q
s5 = {1, 2, 3, 4, 5}
se = {0, 2, 4, 6, 8}
s5 | se;   s5.union(se)
# {0, 1, 2, 3, 4, 5, 6, 8}
# {0, 1, 2, 3, 4, 5, 6, 8}
s5 | (3, 6, 9)
# Traceback (most recent call last):
#   File "<pyshell#260>", line 1, in <module>
#     s5 | (3, 6, 9)
# TypeError: unsupported operand type(s) for |: 'set' and 'tuple'
s5.union(3, 6, 9)
# Traceback (most recent call last):
#   File "<pyshell#261>", line 1, in <module>
#     s5.union(3, 6, 9)
# TypeError: 'int' object is not iterable
s5 | {3, 6, 9} | {10, 20};   s5.union((3, 6, 9), [10, 20])
# {1, 2, 3, 4, 5, 6, 9, 10, 20}
# {1, 2, 3, 4, 5, 6, 9, 10, 20}
s5 & se;   s5.intersection(se)
# {2, 4}
# {2, 4}
s5 & {3, 6, 9} & {10, 20};   s5.intersection((3, 6, 9), [10, 20])
# set()
# set()
s5 - se;   s5.difference(se)
# {1, 3, 5}
# {1, 3, 5}
s5 - se - {1, 2};   s5.difference(se, {1, 2})
# {3, 5}
# {3, 5}
s5 ^ se ^ {3, 6, 9};   (s5.symmetric_difference(se)
                          .symmetric_difference((3, 6, 9)))
# {0, 1, 5, 8, 9}
# {0, 1, 5, 8, 9}
# >>>



#Výpis 19.5:	Vytváření množin pomocí generátorové notace
###########################################################################q
{c for c in 'Python'}
# {'y', 'o', 't', 'h', 'P', 'n'}
{x*x for x in range(3, 30, 3) if x&1 == 1}
# {225, 9, 81, 729, 441}
{a+str(n) for a in 'abc' for n in (0,1)}
# {'b1', 'a1', 'c1', 'b0', 'a0', 'c0'}
# >>>



#Výpis 19.6:	Vytváření zamrazených množin
###########################################################################q
ss = {1, 2, 3};   ss
# {1, 2, 3}
fs = frozenset((11, 22, 33));   fs
# frozenset({33, 11, 22})
{ss}
# Traceback (most recent call last):
#   File "<pyshell#215>", line 1, in <module>
#     {ss}
# TypeError: unhashable type: 'set'
{fs, (11, 12, 13)}
# {frozenset({33, 11, 22}), (11, 12, 13)}
frozenset(gen_fibonacci(7))
# frozenset({(5, 8), (1, 1), (4, 5), (3, 3), (6, 13), (2, 2), (7, 21)})
# >>>



#Výpis 19.7:	Jednoprvkové modifikační množinové operace
###########################################################################q
(sm := set(range(0, 5)))
# {0, 1, 2, 3, 4}
sm.add(20);   sm
# {0, 1, 2, 3, 4, 20}
sm.discard(5);   sm
# {0, 1, 2, 3, 4, 20}
sm.discard(20);   sm
# {0, 1, 2, 3, 4}
sm.remove(0);   sm
# {1, 2, 3, 4}
sm.remove(5);   sm
# Traceback (most recent call last):
#   File "<pyshell#288>", line 1, in <module>
#     sm.remove(5);   sm
# KeyError: 5
sm = {11, 22, 33, 44}
while sm: print(f'Odebráno: {sm.pop()}, zbývá: {sm}')

# Odebráno: 33, zbývá: {11, 44, 22}
# Odebráno: 11, zbývá: {44, 22}
# Odebráno: 44, zbývá: {22}
# Odebráno: 22, zbývá: set()
sm.pop()
# Traceback (most recent call last):
#   File "<pyshell#21>", line 1, in <module>
#     sm.pop()
# KeyError: 'pop from an empty set'
# >>>



#Výpis 19.8:	Modifikace množin množinami či jinými zdroji
###########################################################################q
def si():
    """Inicializace množin pro následující příklady"""
    global sa, sb, s2, s3, ra, rb, r2, r3, ta, tb, t2, t3
    sa = {1, 2, 3, 4};     ra = range(1, 5);       ta = tuple(ra)
    sb = {1, 2, 3, 4};     rb = range(1, 5);       tb = tuple(rb)
    s2 = {2, 4, 6, 8};     r2 = range(2, 9, 2);    t2 = tuple(r2)
    s3 = {3, 6, 9};        r3 = range(3,10, 3);    t3 = tuple(r3)

si();   print((sa, sb, s2, s3), (ta, tb, t2, t3), sep='\n')
# ({1, 2, 3, 4}, {1, 2, 3, 4}, {8, 2, 4, 6}, {9, 3, 6})
# ((1, 2, 3, 4), (1, 2, 3, 4), (2, 4, 6, 8), (3, 6, 9))
si();   sa |= s2;   sb |= s2 | s3;   sa, sb
# ({1, 2, 3, 4, 6, 8}, {1, 2, 3, 4, 6, 8, 9})
si();   sa.update(r2);   sb.update(r2, r3);   sa, sb
# ({1, 2, 3, 4, 6, 8}, {1, 2, 3, 4, 6, 8, 9})
si();   sa &= s2;   sb &= s2 & s3;   sa, sb
# ({2, 4}, set())
si();   sa.intersection_update(r2);  sb.intersection_update(r2, r3);  sa,sb
# ({2, 4}, set())
si();   sa -= s2;   sb -= s2 | s3;   sa, sb
# ({1, 3}, {1})
si();   sa.difference_update(r2);   sb.difference_update(r2, r3);   sa, sb
# ({1, 3}, {1})
si();   sa ^= s2;   sb ^= s3;   sa, sb
# ({1, 3, 6, 8}, {1, 2, 4, 6, 9})
si();   sa.symmetric_difference_update(r2);   \
        sb.symmetric_difference_update(r3);   sa, sb
# ({1, 3, 6, 8}, {1, 2, 4, 6, 9})
# >>>



#Výpis 19.8:	Porovnání množin
###########################################################################q
{1, 2, 3}.isdisjoint({4, 5, 6}),   {1, 2, 3}.isdisjoint({3, 4, 5})
# (True, False)
s12 = {1, 2};   s123 = {1, 2, 3};   s23 = {2, 3}
s12.issubset(s123), s123.issubset(s123), s123.issubset(s23)
# (True, True, False)
s12 <= s123,   s123 <= s123,   s123 <= s23,   s23 <= s123
# (True, True, False, True)
s12 < s123,   s123 < s123,   s123 < s23,   s23 < s123,
# (True, False, False, True)
s12.issuperset(s123), s123.issuperset(s123), s123.issuperset(s23)
# (False, True, True)
s12 >= s123,   s123 >= s123,   s123 >= s23,   s23 >= s123,
# (False, True, True, False)
s12 > s123,   s123 > s123,   s123 > s23,   s23 > s123,
# (False, False, True, False)
# >>>



#Výpis 19.0:	Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
