#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m20__Slovníky.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
20  Slovníky.

Co se v kapitole naučíte
Tato kapitola vás nejprve seznámí s mapovacími objekty, aby se pak
soustředila na nejpoužívanější z nich – instance třídy dict neboli slovníky.
Naučí vás je vytvářet, využívat jejich generátorovou notaci
a představí vám základní operace pro práci se slovníky.
Na závěr vás ještě seznámí s pohledy a možnostmi jejich vyžití.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 20.1:	Vytváření slovníků pomocí literálů
###########################################################################q
d123 = {'Raz':1, 'Dva':2, 'Tři':3};   d123
# {'Raz': 1, 'Dva': 2, 'Tři': 3}
d132 = {'Raz':1, 'Tři':3, 'Dva':2};   d132
# {'Raz': 1, 'Tři': 3, 'Dva': 2}
d123 == d132
# True
import turtle
(dmix := {(1,2):'n-tice', min:'funkce', 3.14:'číslo', turtle:'modul'})
# {(1, 2): 'n-tice', <built-in function min>: 'funkce', 3.14: 'číslo', <module 'turtle' from 'Ca:\\_PGM\\Python\\Python39\\lib\\turtle.py'>: 'modul'}
d0 = {};   print(d0, type(d0))
# {} <class 'dict'>
org = {
    'Praha':{'vedoucí':'Petr',  'výkonný':'Pavel', 'pomocný':'Pepa'},
    'Brno' :{'vedoucí':'Bohouš','výkonný':'Bohdan','pomocný':'Bob'}}
# >>>



#Výpis 20.2:	Vytváření slovníků pomocí funkce dict()
###########################################################################q
d213 = dict(Dva=2, Raz=1, Tři=3,);   d213
# {'Dva': 2, 'Raz': 1, 'Tři': 3}
d231 = dict([('Dva',2), ('Tři',3), ('Raz',1)]);   d231
# {'Dva': 2, 'Tři': 3, 'Raz': 1}
d312 = dict([('Tři',3), ('Raz',1)], Dva=2);   d312
# {'Tři': 3, 'Raz': 1, 'Dva': 2}
d321 = dict(zip(('Tři', 'Dva', 'Raz', 'Nic'), range(3, 0, -1)));   d321
# {'Tři': 3, 'Dva': 2, 'Raz': 1}
d123 == d132 == d213 == d231 == d312 == d321
# True
# >>>



#Výpis 20.3:	Vytváření slovníků pomocí funkce fromkeys()
###########################################################################q
dict.fromkeys((list, tuple, set, frozenset, dict))
# {<class 'list'>: None, <class 'tuple'>: None, <class 'set'>: None, <class 'frozenset'>: None, <class 'dict'>: None}
dict.fromkeys(((0,0), (0,1), (1,0), (1,1)), False)
# {(0, 0): False, (0, 1): False, (1, 0): False, (1, 1): False}
# >>>



#Výpis 20.4:	Vytváření slovníků pomocí generátorové notace
###########################################################################q
{c : hex(ord(c)) for c in 'ABCD'}
# {'A': '0x41', 'B': '0x42', 'C': '0x43', 'D': '0x44'}
slovy = ('Nic', 'Raz', 'Dva', 'Tři')
(ss := {d for d in zip(range(len(slovy)), slovy)}),   type(ss)
# ({(2, 'Dva'), (3, 'Tři'), (0, 'Nic'), (1, 'Raz')}, <class 'set'>)
(d1 := {d[0]:d[1] for d in zip(range(len(slovy)), slovy)}),   type(d1)
# ({0: 'Nic', 1: 'Raz', 2: 'Dva', 3: 'Tři'}, <class 'dict'>)
(d2 := {x:y for x, y in zip(range(len(slovy)), slovy)}),   type(d2)
# ({0: 'Nic', 1: 'Raz', 2: 'Dva', 3: 'Tři'}, <class 'dict'>)
# >>>



#Výpis 20.5:	Přístup k položkám prostřednictvím klíčů
###########################################################################q
empty = {}
empty[list]=[];  empty[tuple]=();  empty[set]=set();  empty[dict]={}
empty
# {<class 'list'>: [], <class 'tuple'>: (), <class 'set'>: set(), <class 'dict'>: {}}
def pre(object): print(object, to:=type(object), object==empty[to])

pre([]);   pre((1,));   pre(());   pre(1)
# [] <class 'list'> True
# (1,) <class 'tuple'> False
# () <class 'tuple'> True
# Traceback (most recent call last):
#   File "<pyshell#61>", line 1, in <module>
#     pre([]);   pre((1,));   pre(());   pre(1)
#   File "<pyshell#57>", line 1, in pre
#     def pre(object): print(object, to:=type(object), object==empty[to])
# KeyError: <class 'int'>
del empty[dict];   empty
# {<class 'list'>: [], <class 'tuple'>: (), <class 'set'>: set()}
# >>>



#Výpis 20.6:	Metody pro práci s jednotlivými položkami
###########################################################################q
d = {'Nic':0, 'Raz':1, 'Dva':2, 'Tři':3};   d
# {'Nic': 0, 'Raz': 1, 'Dva': 2, 'Tři': 3}
d.get('Dva'),   d.get('Xxx', 'Chybí!'),   d.get('Xxx'),   d
# (2, 'Chybí!', None, {'Nic': 0, 'Raz': 1, 'Dva': 2, 'Tři': 3})
d.pop('Dva'),   d.pop('Xxx', 'Chybí!'),   d
# (2, 'Chybí!', {'Nic': 0, 'Raz': 1, 'Tři': 3})
d.popitem(),   d
# (('Tři', 3), {'Nic': 0, 'Raz': 1})
d.popitem(),   d
# (('Raz', 1), {'Nic': 0})
d.setdefault('Nic'),   d
# (0, {'Nic': 0})
d.setdefault('Dva', 2),   d
# (2, {'Nic': 0, 'Dva': 2})
d.setdefault('Tři'),   d
# (None, {'Nic': 0, 'Dva': 2, 'Tři': None})
# >>>



#Výpis 20.7:	Použití metody update()
###########################################################################q
d;   d.update({'Raz': 1, 'Dva': 2, 'Tři': 3});   d
# {'Nic': 0, 'Dva': 2, 'Tři': None}
# {'Nic': 0, 'Dva': 2, 'Tři': 3, 'Raz': 1}
d.update(zip('AB', (10, 11)));   d
# {'Nic': 0, 'Dva': 2, 'Tři': 3, 'Raz': 1, 'A': 10, 'B': 11}
# >>>



#Výpis 20.8:	Pohledy
###########################################################################q
d = dict(Raz=1, Dva=2, Tři=3,)
dk = d.keys();   dv = d.values();   di = d.items();   d; dk; dv; di;
# {'Raz': 1, 'Dva': 2, 'Tři': 3}
# dict_keys(['Raz', 'Dva', 'Tři'])
# dict_values([1, 2, 3])
# dict_items([('Raz', 1), ('Dva', 2), ('Tři', 3)])
d['Tři'] = 3.14;   d['Čty'] = 4;   d; dk; dv; di;
# {'Raz': 1, 'Dva': 2, 'Tři': 3.14, 'Čty': 4}
# dict_keys(['Raz', 'Dva', 'Tři', 'Čty'])
# dict_values([1, 2, 3.14, 4])
# dict_items([('Raz', 1), ('Dva', 2), ('Tři', 3.14), ('Čty', 4)])
# >>>



#Výpis 20.9:	Pohledy jako generátory
###########################################################################q
def prd(source):
    """Vytiskne data dodaná zadaným zdrojem."""
    for item in source: print(item, end='-')
    print()

prd(d);   prd(d.keys())
# Raz-Dva-Tři-Čty-
# Raz-Dva-Tři-Čty-
prd(d.values());   prd(d.items())
# 1-2-3.14-4-
# ('Raz', 1)-('Dva', 2)-('Tři', 3.14)-('Čty', 4)-
list(d);   set(d.items())
# ['Raz', 'Dva', 'Tři', 'Čty']
# {('Dva', 2), ('Čty', 4), ('Raz', 1), ('Tři', 3.14)}
# >>>



#Výpis 20.10:	Operace s pohledy
###########################################################################q
d3 = {'Raz':11, 'Dva':22, 'Tři':33}
d4 = {'Čty':40, 'Raz':10, 'Dva':20}
s = d3.keys() & d4.keys();  (type(s), s)
# (<class 'set'>, {'Dva', 'Raz'})
d3.items() | d4.items()
# {('Dva', 20), ('Čty', 40), ('Raz', 11), ('Dva', 22), ('Tři', 33), ('Raz', 10)}
[d3[i] - d4[i] for i in d3.keys() & d4.keys()]
# [2, 1]
{i: d3[i]-d4[i] for i in d3.keys() & d4.keys()}
# {'Dva': 2, 'Raz': 1}
{i:(d3.get(i,0)+d4.get(i,0)) / ((d3.get(i,0)>0)+(d4.get(i, 0)>0))
 for i in d3.keys() | d4.keys()}
# {'Tři': 33.0, 'Čty': 40.0, 'Dva': 21.0, 'Raz': 10.5}
# >>>



#Výpis 20.0:	Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
