#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m22__Operace_se_stringy.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
22  Operace se stringy a formátování.

Co se v kapitole naučíte
Tato kapitola se vrací ke stringům a soustředí se především na problematiku
jejich formátování. Představí nejprve některé užitečné metody stringů
a poté ve stručnosti probere starší techniku formátování prostřednictvím
operátoru %. Poté se už soustředí na možnosti poskytované metodou format()
a na tzv. f stringy, které umožňují zadávat formátování prostřednictvím
stringových literálů.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 22.1:	Použití formátovacího operátoru
###########################################################################q
"%s hoří při %d stupních %s." % ("Papír", 451, "Fahrenheita")
# 'Papír hoří při 451 stupních Fahrenheita.'
'%*.*s = %.*f' % (6, 3, 'Prodloužení', 3, 2.7182)
# '   Pro = 2.718'
format = '%(název)s je %(typ)s %(konzument)s.'
format % {'název':'Ambrosie', 'typ':'pokrm', 'konzument':'bohů'}
# 'Ambrosie je pokrm bohů.'
format % dict(název='Nektar', typ='nápoj', konzument='bohů')
# 'Nektar je nápoj bohů.'
sada = ('název', 'typ', 'konzument')
format % dict(zip(sada, ('Pivo', 'tekutý chléb', 'Čechů')))
# 'Pivo je tekutý chléb Čechů.'
# >>>



#Výpis 22.2:	Použití prázdné formátové položky
###########################################################################q
a0, a1, a2, a3 = 'Nic', 'Raz', 'Dva', 'Tři'
"První argument={}, druhý argument={}.".format(a1, a2); \
f"První argument={a1}, druhý argument={a2}."
# 'První argument=Raz, druhý argument=Dva.'
# 'První argument=Raz, druhý argument=Dva.'
'Použití závorek: {{ {} }}, {{{}}}'.format(a0, a1); \
f'Použití závorek: {{ {a0} }}, {{{a1}}}'
# 'Použití závorek: { Nic }, {Raz}'
# 'Použití závorek: { Nic }, {Raz}'
# >>>



#Výpis 22.3:	Různé způsoby zadávání nahrazovaného textu
###########################################################################q
'Dvojka:{2}, nula:{0}, jednička:{1}.'.format(a0, a1, a2); \
'Dvojka:{a2}, nula:{a0}, jednička:{a1}.'
# 'Dvojka:Dva, nula:Nic, jednička:Raz.'
# 'Dvojka:Dva, nula:Nic, jednička:Raz.'
'Argumenty: ({Nula}, {0}, {1})'.format(a1, a2, Nula=a0); \
f'Argumenty: ({a0}, {a1}, {a2})'
# 'Argumenty: (Nic, Raz, Dva)'
# 'Argumenty: (Nic, Raz, Dva)'
'Jedna:{}, dva:{1}, Nula:{2}.'.format(a1, a2, a0)
# Traceback (most recent call last):
#   File "<pyshell#2>", line 1, in <module>
#     'Jedna:{}, dva:{1}, Nula:{2}.'.format(a1, a2, a0)
# ValueError: cannot switch from automatic field numbering to manual field specification
lst = [abs, bin, chr];      dct = {'A0':a0.upper(), 'A1':a1.upper()}
'Funkce {0[0]} # {0[1].__name__} # {A1}'.format(lst, **dct); \
f'Funkce {lst[0]} # {lst[1].__name__} # {dct["A1"]}'
# 'Funkce <built-in function abs> # bin # RAZ'
# 'Funkce <built-in function abs> # bin # RAZ'
# >>>



#Výpis 22.4:	Efekt zadání konverze konverzí
###########################################################################q
'ASCII: {0!a},  System: {0!r},  User: {0!s}'.format('Příklad'); \
f'ASCII: {(_:="Příklad")!a},  System: {_!r},  User: {_!s}'
# "ASCII: 'P\\u0159\\xedklad',  System: 'Příklad',  User: Příklad"
# "ASCII: 'P\\u0159\\xedklad',  System: 'Příklad',  User: Příklad"
# >>>



#Výpis 22.5:	Zadání požadovaného minimálního počtu pozic
###########################################################################q
p = 'Python';   n=123;   from math import pi
'{0:4}|{0:8}|{1:2}|{1:3}|{1:4}|{2:4}'.format(p, n, pi); \
f'{p:4}|{p:8}|{n:2}|{n:3}|{n:4}|{pi:4}'
# 'Python|Python  |123|123| 123|3.141592653589793'
# 'Python|Python  |123|123| 123|3.141592653589793'
'{0}|{0:5}|{0!s:1}|{1}|{1:5}|{1!a:5}|'.format(False, True); \
f'{(_:=False)}|{_:5}|{_!s:1}|{(_:=True)}|{_:5}|{_!a:5}|'
# 'False|    0|False|True|    1|True |'
# 'False|    0|False|True|    1|True |'
# >>>



#Výpis 22.6:	Zadání požadované přesnosti, resp. maximálního počtu pozic
###########################################################################q
'{0:8.4}|{0:.4}|{1!s:.5}|{1!s:5.2}|'.format(p, True); \
f'{p:8.4}|{p:.4}|{True!s:.5}|{True!s:5.2}|'
# 'Pyth    |Pyth|True|Tr   |'
# 'Pyth    |Pyth|True|Tr   |'
for n in range(-2, 4):
    s1 =  '{0:2}: {1:8.3} -- {1:.4}'.format(n, pi * 10**n)
    s2 = f'{n:2}: {(_:=pi*10**n):8.3} -- {_:.4}'
    print(s1, (30-len(s1))*' ', s2)

# -2:   0.0314 -- 0.03142         -2:   0.0314 -- 0.03142
# -1:    0.314 -- 0.3142          -1:    0.314 -- 0.3142
#  0:     3.14 -- 3.142            0:     3.14 -- 3.142
#  1:     31.4 -- 31.42            1:     31.4 -- 31.42
#  2: 3.14e+02 -- 314.2            2: 3.14e+02 -- 314.2
#  3: 3.14e+03 -- 3.142e+03        3: 3.14e+03 -- 3.142e+03
# >>>



#Výpis 22.7:	Typy formátů pro celočíselné hodnoty
###########################################################################q
"{0:b} - {0:o} - {0:d} - {0:x} - {0:X} - '{0:c}'".format(0x263a); \
f"{(_:=0x263a):b} - {_:o} - {_:d} - {_:x} - {_:X} - '{_:c}'"
# "10011000111010 - 23072 - 9786 - 263a - 263A - '☺'"
# "10011000111010 - 23072 - 9786 - 263a - 263A - '☺'"
# >>>



#Výpis 22.8:	Typy formátů pro zobrazení reálných čísel
###########################################################################q
for n in range(-4, 4):
    print("{0:2}: {1:8.3f} -- {1:8.3g} -- {1:8.3E} -- {1}"
          .format(n, pi * 10**n))

# -4:    0.000 -- 0.000314 -- 3.142E-04 -- 0.0003141592653589793
# -3:    0.003 --  0.00314 -- 3.142E-03 -- 0.0031415926535897933
# -2:    0.031 --   0.0314 -- 3.142E-02 -- 0.031415926535897934
# -1:    0.314 --    0.314 -- 3.142E-01 -- 0.3141592653589793
#  0:    3.142 --     3.14 -- 3.142E+00 -- 3.141592653589793
#  1:   31.416 --     31.4 -- 3.142E+01 -- 31.41592653589793
#  2:  314.159 --      314 -- 3.142E+02 -- 314.1592653589793
#  3: 3141.593 -- 3.14e+03 -- 3.142E+03 -- 3141.592653589793
'{0:.2f} -- {0:.1e}'.format(1+2j); \
f'{1+2j:.2f} -- {1+2j:.1e}'
# '1.00+2.00j -- 1.0e+00+2.0e+00j'
# '1.00+2.00j -- 1.0e+00+2.0e+00j'
# >>>



#Výpis 22.9:	Zadání oddělovačů skupin
###########################################################################q
x = 76_543;    y = 1_234.567_89
'{0:,d}, {0:_d}, {0:_b}, {0:_o}, {0:_x}, {0:_X}'.format(x); \
f'{x:,d}, {x:_d}, {x:_b}, {x:_o}, {x:_x}, {x:_X}'
# '76,543, 76_543, 1_0010_1010_1111_1111, 22_5377, 1_2aff, 1_2AFF'
# '76,543, 76_543, 1_0010_1010_1111_1111, 22_5377, 1_2aff, 1_2AFF'
'{0:_f}, {0:_}, {0:_g}'.format(y); \
f'{y:_f}, {y:_}, {y:_g}'
# '1_234.567890, 1_234.56789, 1_234.57'
# '1_234.567890, 1_234.56789, 1_234.57'
'{:_f}'.format(12_345_678_901_234_567_890_123_456_789.); \
f'{12_345_678_901_234_567_890_123_456_789.:_f}' \
; '12_345_678_901_234_567_890_123_456_789.'
# '12_345_678_901_234_571_227_576_610_816.000000'
# '12_345_678_901_234_571_227_576_610_816.000000'
# '12_345_678_901_234_567_890_123_456_789.'
# >>>



#Výpis 22.10:	Zadání alternativního formátu
###########################################################################q
'{0:#_d}, {0:#_b}, {0:#_o}, {0:#_x}, {0:#_X}'.format(x); \
f'{x:#_d}, {x:#_b}, {x:#_o}, {x:#_x}, {x:#_X}'
# '76_543, 0b1_0010_1010_1111_1111, 0o22_5377, 0x1_2aff, 0X1_2AFF'
# '76_543, 0b1_0010_1010_1111_1111, 0o22_5377, 0x1_2aff, 0X1_2AFF'
'{0:.0f} - {0:#.0f} # {0:.0} - {0:#.0} # {0:.1g} - {0:#.1g}'.format(1.5); \
f'{(_:=1.5):.0f} - {_:#.0f} # {_:.0} - {_:#.0} # {_:.1g} - {_:#.1g}'
# '2 - 2. # 2e+00 - 2.e+00 # 2 - 2.'
# '2 - 2. # 2e+00 - 2.e+00 # 2 - 2.'
'{0:.2f} - {0:#.2f} # {0:.2e} - {0:#.2e} # {0:.3g} - {0:#.3g}'.format(1); \
f'{1:.2f} - {1:#.2f} # {1:.2e} - {1:#.2e} # {1:.3g} - {1:#.3g}'
# '1.00 - 1.00 # 1.00e+00 - 1.00e+00 # 1 - 1.00'
# '1.00 - 1.00 # 1.00e+00 - 1.00e+00 # 1 - 1.00'
'{0:.2}'.format(1)
# Traceback (most recent call last):
#   File "<pyshell#59>", line 1, in <module>
#     '{0:.2}'.format(1)
# ValueError: Precision not allowed in integer format specifier
# >>>



#Výpis 22.11:	Zarovnání a plnění
###########################################################################q
p = 'Python';   n=123;   nn = -n;   from math import pi
'{p:10}|{n:10}|{n!s:10}|{pi:10.3}|'.format(p=p, n=n, pi=pi); \
f'{p:10}|{n:10}|{n!s:10}|{pi:10.3}|'
# 'Python    |       123|123       |      3.14|'
# 'Python    |       123|123       |      3.14|'
'{0:\x3d<10}|{0:.^10}|{0:>>10}'.format(p); \
f'{R:\x3d<10}|{p:.^10}|{p:>>10}'
# 'Python====|..Python..|>>>>Python'
# 'Python====|..Python..|>>>>Python'
'{n:>7}|{n:0>7}|{n:0>+7}|{n:0> 7}|{nn:0> 7}|'.format(n=n, nn=nn); \
'{n:=7}|{n:0=7}|{n:0=+7}|{n:0= 7}|{nn:0= 7}|'.format(n=n, nn=nn); \
 '{n:7}|{n:=07}|{n:=+07}|{n:= 07}|{nn:= 07}|'.format(n=n, nn=nn)
# '    123|0000123|000+123|000 123|000-123|'
# '    123|0000123|+000123| 000123|-000123|'
# '    123|0000123|+000123| 000123|-000123|'
f'{n:>7}|{n:0>7}|{n:0>+7}|{n:0> 7}|{nn:0> 7}|'; \
f'{n:=7}|{n:0=7}|{n:0=+7}|{n:0= 7}|{nn:0= 7}|'; \
 f'{n:7}|{n:=07}|{n:=+07}|{n:= 07}|{nn:= 07}|'
# '    123|0000123|000+123|000 123|000-123|'
# '    123|0000123|+000123| 000123|-000123|'
# '    123|0000123|+000123| 000123|-000123|'
# >>>



#Výpis 22.12:	Používání vnořených nahrazovacích polí
###########################################################################q
'{0:{1}>10}|{0:.^10}|{0:{2}<10}'.format(p, '{', '}'); \
f'{p:{"{"}>10}|{p:.^10}|{p:{"}"}<10}'
# '{{{{Python|..Python..|Python}}}}'
# '{{{{Python|..Python..|Python}}}}'
for a in range(3, 10, 3):
    print((_:='{:.{}f}'.format(pi, a)), ' '*(15-len(_)),
             f'{pi:.{a}f}' )

# 3.142            3.142
# 3.141593         3.141593
# 3.141592654      3.141592654
# >>>



###########################################################################q
#Kap 22.3.i  Formátování samodokumentujících se nahrazovacích polí
###########################################################################q
n=0xABCD; f"{n*n=:_d} # {(n*16 + n%16)=:#x} # {n=:#_b}"
# 'n*n=1_934_328_361 # (n*16 + n%16)=0xabcdd # n=0b1010_1011_1100_1101'
# >>>



#Výpis 22.13:	Definice funkce printpasf() v modulu m22a_PrintPasF
###########################################################################q

""" Je uloženo v souboru
m22a_PrintPasF.py
"""



#Výpis 22.14:	Použití funkce printpasf() v modulu m22a_PrintPasF
###########################################################################q
from m17a_Pascal import pascal
# ===== Modul m17a_Pascal ===== START
# ===== Modul m17a_Pascal ===== STOP
from m22a_PrintPasF import printpasf
# ===== Modul m22a_PrintPasF ===== START
# ===== Modul m22a_PrintPasF ===== STOP
print(printpasf(pascal(10)))
#                    1
#                  1   1
#                1   2   1
#              1   3   3   1
#            1   4   6   4   1
#          1   5   10  10  5   1
#        1   6   15  20  15  6   1
#      1   7   21  35  35  21  7   1
#    1   8   28  56  70  56  28  8   1
#  1   9   36  84 126 126  84  36  9   1
#
# >>>



#Výpis 22.15:	Trasovací funkce prSE() v modulu dbg
###########################################################################q

""" Je uloženo v souboru
dbg.py
"""



#Výpis 22.16:	Trasovací funkce prIN() v modulu dbg
###########################################################################q

""" Je uloženo v souboru
dbg.py
"""



#Výpis 22.17:	Ukázka použití trasovacích funkcí prSE() a prIN()
###########################################################################q
def fce(n):
    dbg.prSE(0, 1, 'fce', f"Na hladině {n=}")
    if n>0:
        dbg.prIN(0, f'Sestupujeme na hladinu {n-1}')
        fce(n-1)
    dbg.prSE(0, 0, 'fce')

fce(2)
# ==> fce - Na hladině n=2
# |   Sestupujeme na hladinu 1
# |   ==> fce - Na hladině n=1
# |   |   Sestupujeme na hladinu 0
# |   |   ==> fce - Na hladině n=0
# |   |   <== fce
# |   <== fce
# <== fce
dbg.prSE.start = '+->'
dbg.prSE.inc   = '|  '
dbg.prSE.end   = '+<-'
fce(3)
# +->fce - Na hladině n=3
# |  Sestupujeme na hladinu 2
# |  +->fce - Na hladině n=2
# |  |  Sestupujeme na hladinu 1
# |  |  +->fce - Na hladině n=1
# |  |  |  Sestupujeme na hladinu 0
# |  |  |  +->fce - Na hladině n=0
# |  |  |  +<-fce
# |  |  +<-fce
# |  +<-fce
# +<-fce
# >>>



#Výpis 22.Y:	Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
