#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ ó
#R:/71_INP/m23__Operace_s_kontejnery.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
23  Operace s kontejnery.

Co se v kapitole naučíte
Rozšířením datových typů o kontejnery se naše možnosti výrazně rozšířily.
Prozatím jsme u každého typu kontejneru probírali pouze funkce
specifické pro daný typ. Nyní se soustředíme na funkce
společné pro všechny kontejnery nebo alespoň jejich skupiny.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 23.1:	Hluboké a mělké kopie
###########################################################################q
L1 = [1];   L2 = [2];   L3 = [3];   lst = [L1, L2]
from copy import deepcopy
shc = lst.copy();   dpc = deepcopy(lst);   f"{lst=}, {shc=}, {dpc=}"
# 'lst=[[1], [2]], shc=[[1], [2]], dpc=[[1], [2]]'
L1[0] = 11;   f"{lst=}, {shc=}, {dpc=}"
# 'lst=[[11], [2]], shc=[[11], [2]], dpc=[[1], [2]]'
lst[1] = L3;   f"{lst=}, {shc=}, {dpc=}"
# 'lst=[[11], [3]], shc=[[11], [2]], dpc=[[1], [2]]'
fst = frozenset((1, 2, 3));   fst2 = fst.copy()
fst is fst2
# True
# >>>



#Výpis 23.2:	Použití operátorů in a not in
###########################################################################q
p = 'python'
print(f'{("y" in p)=},  {("th" in p)=},  {("yo" in p)=}')
# ("y" in p)=True,  ("th" in p)=True,  ("yo" in p)=False
t123 = (1, 2, 3, )
print(f'{(1 in t123)=},  {(0 in t123)=},  {((1,2) in t123)=}')
# (1 in t123)=True,  (0 in t123)=False,  ((1,2) in t123)=False
r5 = range(5)
print(f'{(0 in r5)=},  {(4 in r5)=},  {(5 in r5)=}')
# (0 in r5)=True,  (4 in r5)=True,  (5 in r5)=False
print(f'{("yo" not in p)=},  {(1 not in t123)=},  {(5 not in r5)=}')
# ("yo" not in p)=True,  (1 not in t123)=False,  (5 not in r5)=True
# >>>



#Výpis 23.3:	Použití funkce reversed()
###########################################################################q
dir = {11:'Raz', 22:'Dva', 33:'Tři'}
for x in reversed(dir): print(f'{x}->{dir[x]}', end=';  ')

# 33->Tři;  22->Dva;  11->Raz;
lst = [10, 20, 30];   tuple(reversed(lst))
(30, 20, 10)
list(reversed('Python'))
# ['n', 'o', 'h', 't', 'y', 'P']
# >>>



#Výpis 23.4:	Použití funkce sorted()
###########################################################################q
sorted('Python');   sorted('Python',  reverse=True)
# ['P', 'h', 'n', 'o', 't', 'y']
# ['y', 't', 'o', 'n', 'h', 'P']
sorted({100, 13, 35, 637, 982, 20}, key=lambda n: n % 10)
# [100, 20, 982, 13, 35, 637]
sorted({'Alfa', 'Beta', 'Gama'}, reverse=True)
# ['Gama', 'Beta', 'Alfa']
dir = {11:'Raz', 22:'Dva', 33:'Tři'}
sorted(dir.items(), key = lambda t: t[1])
# [(22, 'Dva'), (11, 'Raz'), (33, 'Tři')]
# >>>



#Výpis 23.5:	Indexování a vykrajování u rozsahů – objektů typu range
###########################################################################q
r = range(0, 100, 11)
r[3], r[-1]
# (33, 99)
r[3:7],   r[:5],   r[5:]
# (range(33, 77, 11), range(0, 55, 11), range(55, 110, 11))
r, (rr:=r[:])
# (range(0, 100, 11), range(0, 110, 11))
rr[-1],   r[:][-1],   r == rr
# (99, 99, True)
r[5:5]
# range(55, 55, 11)
for i in r[5:5]:
    print('Prošlo')
else: print('Konec')

# Konec
len(range(0, 100, 11)), len(range(0, 110, 11)), len(r[5:5])
# (10, 10, 0)
# >>>



#Výpis 23.6:	Modifikace obsahu posloupnosti
###########################################################################q
ls = list('Python');   ls[0], ls[2:5], ls[-1]
# ('P', ['t', 'h', 'o'], 'n')
ls[1] = 'a';   ls[-1] = 's';   ls
# ['P', 'a', 't', 'h', 'o', 's']
ls[1] = ['o', 'r'];   ls
# ['P', ['o', 'r'], 't', 'h', 'o', 's']
ls[1:2]
# [['o', 'r']]
ls[1:2] = ['o', 'r'];   ls
# ['P', 'o', 'r', 't', 'h', 'o', 's']
ls[4:5] = [];   ls
# ['P', 'o', 'r', 't', 'o', 's']
ls[4:4] = 'h';   ls
# ['P', 'o', 'r', 't', 'h', 'o', 's']
# >>>



#Výpis 23.7:	Postup při výměně prvku v n tici
###########################################################################q
tpl = ('a', 'b', 'c', 'd', 'e')
# tpl[2] = 'c#'    # U n-tice nelze
tpl = tpl[:2]  +  ('c#',)  +  tpl[3:];   tpl
# ('a', 'b', 'c#', 'd', 'e')
# >>>



#Výpis 23.Y:	Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
