#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m26__Třídy_a_jejich_instance.py
"""
Příkazy zadávané ve výpisech kapitoly:
26  Třídy a jejich instance
"""
import dbg; dbg.start_mod(1, __name__)
###########################################################################q



#Výpis 26.1:	Definice třídy a jejích atributů
###########################################################################q
class C0: """Třída s prázdným tělem"""

class C1:
    """Třída definující svůj datový, funkční i typový atribut,
       tj. datovou proměnnou, metodu a třídu.
       Současně demonstruje spouštění příkazů v těle při definici.
    """
    print('START definice třídy C1')
 
    ca = 'Atribut ca třídy C1'
 
    def cm():
        """Statická metoda třídy C1 -- volá se "C1.cm()"."""
        print('Byla zavolána metoda C1.cm')
 
    class C11:
        """Vnitřní třída třídy C1 - oslovuje se "C1.C11".
           Má vlastní datový atribut a funkční atribut (metodu).
        """
        print('START definice třídy C1.C11')
        ca = 'Atribut ca třídy C1.C11'
 
        def cm():
            """Statická metoda třídy C11 - volá se "C1.C11.cm()"."""
            print('Byla zavolána metoda C1.C11.cm')
 
        print('KONEC definice třídy C1.C11')
 
    print('KONEC definice třídy C1')

f'{type(C0)=}, {type(C1)=}, {type(C1.C11)=}'



#Výpis 26.2:	Práce s atributy objektu
###########################################################################q
C1.ca,   C1.C11.ca;   C1.cm();   C1.C11.cm()
C1.ca = 'Upravený atribut třídy C1'
f'{C1.ca =}'



#Výpis 26.3:	Přidávání a odstraňování atributů objektu
###########################################################################q
f"{C0.ca =}"
C0.ca = 'Atribut třídy C0'
f"{C0.ca =}"
del C0.ca



#Výpis 26.4:	Přidávání a odstraňování metody
###########################################################################q
C0.cm = lambda: print('Byla zavolána metoda C0.cm')
C0.cm()
def C0_cm():
    print(f'Byla zavolána verze nazvaná {C0.cm.__name__}')

C0.cm = C0_cm;    C0.cm()
C0_cm.__name__ = 'cm';    del C0_cm
C0_cm()
C0.cm()



#Výpis 26.5:	Třída jako parametr funkce
###########################################################################q
def method(cls):
    print(f'Třída {cls.__name__} - ', end='')
    cls.cm()

method(C0);   method(C1);   method(C1.C11)



#Výpis 26.6:	Vytvoření prvních instancí
###########################################################################q
c1a = C1()   # Vytvářím instanci třídy C1
print(f'{type(c1a) = }\n{     c1a  = }\n{C0()      = }')



#Výpis 26.7:	Kvalifikace atributu třídy instancí
###########################################################################q
c1a.ca
c1a.cm()
C1.cm = staticmethod(C1.cm)
c1a.cm()



#Výpis 26.8:	Možná použití dekorátoru
###########################################################################q
class C26a:
    """Demonstrace použití dekorátorů."""
                                                                    #SYNC
    def inst(self): return f"{self.__class__.__name__}[{id(self):#_x}]"
                                                                    #SYNC
    def class0(cls): return f"Metoda třídy {cls.__name__} - PO"
    class0 = classmethod(class0)
                                                                    #SYNC
    @classmethod
    def class1(cls): return f"Metoda třídy {cls.__name__} - PŘED"
                                                                    #SYNC
    def static0(): return 'Statická - PO'
    static0 = staticmethod(static0)
                                                                    #SYNC
    @staticmethod
    def static1(): return 'Statická - PŘED'
                                                                    #SYNC
c = C26a();   C26a.inst(c),   c.inst()
C26a().class0(),    c.class0()
C26a().class1(),    c.class1()
C26a().static0(),   c.static0()
C26a().static1(),   c.static1()



#Výpis 26.9	Přidání a použití instanční metody
###########################################################################q
def fce(self): """Potenciální instanční metoda.""";   print(self.ia)

C1.mtd = fce    # Odkaz na funkci přidám mezi třídní atributy
c1a.ia = 'Instanční atribut ia' # Připravím atribut tisknutý funkcí/metodou
fce(c1a);   C1.mtd(c1a);   c1a.mtd()      # Tři způsoby volání



#Výpis 26.10:	Definice třídy C2
###########################################################################q
class C2:
    """Třída definující initor a podpisové metody."""

    ca = 'Atribut třídy C2'
    count = 0     # Inicializace počtu vytvořených instancí

    def __init__(self):
        """Initor instancí třídy C2."""
        C2.count += 1       # Vytvářím další instanci
        self.ID = C2.count  # Identifikační (rodné) číslo instance
        self.ia = f'Atribut {self.ID}. instance třídy C2'
        print(f'Vytvořena {self.ID}. instance třídy C2')

    def im(self, x):
        """Instanční metoda s jedním parametrem."""
        print(f'Metoda instance {self} s parametrem {x=}')

    def __repr__(this):
        """Definice systémového textového podpisu instance."""
        return f'<{C2.__module__}.C2_ {this.ID}>'

    def __str__(moje):
        """Definice uživatelského textového podpisu instance."""
        return (f'«C2_{moje.ID}»')



#Výpis 26.11:	Vytváření instancí třídy C2 a používání jejich atributů
###########################################################################q
c2a=C2();   c2b=C2();   c2c=C2()
c2a,   c2b,   c2c
print(c2a,  c2b,  c2c, sep=', ')
print(f'{c2c.ca} -- {c2c.ia}')
c2b.im('přes instanci')
C2.im(c2c, 'přes třídu')
C2.im(C2(), 'čerstvě vytvořená')



#Výpis 26.12:	Vytváření nových instančních datových atributů
###########################################################################q
c2a.ia2 = f"Druhý atribut instance {c2a}"
c2a.ia2



#Výpis 26.13:	Změny třídních datových atributů
###########################################################################q
C2.ca,   c2a.ca,   c2b.ca
C2.ca = 'Attr_C2.ca'
C2.ca,   c2a.ca,   c2b.ca
C2.ca2 = 'Attr_C2.ca2'
C2.ca2, c2a.ca2, c2b.ca2
c2a.ca = 'Změna'
C2.ca,   c2a.ca,   c2b.ca



#Výpis 26.14:	Třídní datový atribut jako implicitní hodnota instančního
###########################################################################q
class C3:
    """Experimentální třída pro demonstraci lokality atributů."""

    ca = 'Třídní'   # Implicitní hodnota stejnojmenných instančních atributů

    def __init__(self, ca = None):
        """Instanční atribut se vytváří pouze tehdy, je-li zadán argument ca."""
        if ca:  self.ca = ca

    def get_ca(self):
        """Vrací aktuálně platnou hodnotu ca - instanční či třídní."""
        return self.ca

    def __repr__(self):
        """Textový podpis instance používaný systémem."""
        return f'<C3: {self.ca=}>'

c30 = C3();   c31 = C3('Instanční')
print(f'{c30.ca=},   {c31.ca=}')
print(f'Systém:   {c30=!r}   ###   {c31=!r}\n'
      f'Uživatel: {c30=!s}   ###   {c31=!s}')



#Výpis 26.15:	Zavádění nových třídních funkčních atributů
###########################################################################q
def im2(self, text):
    """Funkce určená k přidání do C2 jako nová metoda."""
    print('Druhá metoda instance', self, 's parametrem text =', repr(text))

C2.im2 = im2;    del im2    # Proměnnou s odkazem na funkci smaže
c2a.im2('první');    C2().im2('pátá');    C2.im2(c2c, 'třetí')



#Výpis 26.16:	Zavádění nových instančních funkčních atributů
###########################################################################q
c2a.im3 = lambda self, arg: f'Metoda im3, {self=}, {arg=}'
c2a.im3(c2b, 'Projde')
C2.im3 = c2a.im3;   del c2a.im3
c2a.im3('Už projde')



#Výpis 26.17:	Demonstrace nutnosti kvalifikace atributů
###########################################################################q
class C4:
    """Experimentální třída pro demonstraci lokality názvů"""

    atr = "Třídní"

    def mtd_loc():   atr    = 'Lokální';   return f'mtd_loc - {atr=}'
    def mtd_cls():   C4.atr = 'Změněný';   return f'mtd_cls - {C4.atr=}'
    def mtd_glo():                         return f'mtd_glo - {atr=}'

C4.atr,   C4.mtd_loc(),   C4.atr
C4.atr,   C4.mtd_cls(),   C4.atr
atr = 'Globální'
C4.mtd_glo()



#Výpis 26.18:	Ukázky použití systémových atributů
###########################################################################q
def prDict(d):
    """Vytiskne položky zadaného slovníku, každou na samostatný řádek."""
    for k, v in d.items(): print(k, '=', v)

prDict(C2.__dict__)
prDict(c2a.__dict__)
prDict(c2b.__dict__)



#Výpis 26.0:	Popisek
###########################################################################q
"""
Je uloženo v souboru
#R:/71_INP/xxx.py
"""
##### Kapitola 26.0:	Název
#--------------------------------------------------------------------------q
                                                                       #SYNC
###########################################################################q
dbg.stop_mod(1, __name__)
