#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m27__Jednoduché_dědění.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
27  Jednoduché dědění.

Co se v kapitole naučíte
Teoretické základy dědění jsme probrali v podkapitole 20.8  Dědění
na straně 344. Tato kapitola vás naučí jednoduché dědění v Pythonu zadávat
a vysvětlí vám, jaká pravidla se při jeho používání uplatňují.
Na závěr vám představí zabudované funkce pracující s objekty.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 27.1:	Definice tříd LA, LB a LC v modulu m27a_LABC
###########################################################################q

""" Je uloženo v souboru
m27a_LABC.py
"""



#Výpis 27.2:	Jmenné prostory a dosažitelné atributy tříd z modulu m27a_LABC
###########################################################################q
from m27a_LABC import *
# ===== Modul m27a_LABC ===== START
# ===== Modul m27a_LABC ===== STOP
dbg.prDict(LA);    dbg.prDict(LB);    dbg.prDict(LC)
# ##### Atributy objektu: <class 'm27a_LABC.LA'>
# cA = LA_cc
# cX = LA_cx
# mtdA = <function LA.mtdA at 0x0000029B85897400>
# mtdv = <function LA.mtdv at 0x0000029B85897490>
# ##### Atributy objektu: <class 'm27a_LABC.LB'>
# cB = LB_cc
# cX = LB_cx
# mtdB = <function LB.mtdB at 0x0000029B858975B0>
# mtdv = <function LB.mtdv at 0x0000029B85897640>
# ##### Atributy objektu: <class 'm27a_LABC.LC'>
# cC = LC_cc
# cX = LC_cx
# mtdC = <function LC.mtdC at 0x0000029B85897760>
# mtdv = <function LC.mtdv at 0x0000029B858977F0>
[atr for atr in dir(LC) if atr[0] != '_']
# ['cA', 'cB', 'cC', 'cX', 'mtdA', 'mtdB', 'mtdC', 'mtdv']
# >>>



#Výpis 27.3:	Jmenné prostory a dosažitelné atributy instancí tříd z modulu m27a_LABC
###########################################################################q
a1 = LA(1);    [atr for atr in dir(a1) if atr[0] != '_']
# ==> LA.__init__ - {}
# <== LA.__init__ - {'ID': 1, 'iA': 'LA_ic', 'iX': 'LA_ix'}
# ['ID', 'cA', 'cX', 'iA', 'iX', 'mtdA', 'mtdv']
b1 = LB(1);    [atr for atr in dir(b1) if atr[0] != '_']
# ==> LB.__init__ - {}
# |   ==> LA.__init__ - {}
# |   <== LA.__init__ - {'ID': 1, 'iA': 'LA_ic', 'iX': 'LA_ix'}
# |   Po super: {'ID': 1, 'iA': 'LA_ic', 'iX': 'LA_ix'}
# <== LB.__init__ - {'ID': 1, 'iA': 'LA_ic', 'iX': 'LB_ix', 'iB': 'LB_ic'}
# ['ID', 'cA', 'cB', 'cX', 'iA', 'iB', 'iX', 'mtdA', 'mtdB', 'mtdv']
c1 = LC(1);    [atr for atr in dir(c1) if atr[0] != '_']
# ==> LC.__init__ - {}
# |   ==> LB.__init__ - {}
# |   |   ==> LA.__init__ - {}
# |   |   <== LA.__init__ - {'ID': 1, 'iA': 'LA_ic', 'iX': 'LA_ix'}
# |   |   Po super: {'ID': 1, 'iA': 'LA_ic', 'iX': 'LA_ix'}
# |   <== LB.__init__ - {'ID': 1, 'iA': 'LA_ic', 'iX': 'LB_ix', 'iB': 'LB_ic'}
# |   Po super: {'ID': 1, 'iA': 'LA_ic', 'iX': 'LB_ix', 'iB': 'LB_ic'}
# <== LC.__init__ - {'ID': 1, 'iA': 'LA_ic', 'iX': 'LC_ix', 'iB': 'LB_ic', 'iC': 'LC_ic'}
# ['ID', 'cA', 'cB', 'cC', 'cX', 'iA', 'iB', 'iC', 'iX', 'mtdA', 'mtdB', 'mtdC', 'mtdv']
# >>>



#Výpis 27.4:	Volání metod v hierarchii dědění
###########################################################################q
a1.mtdA(),; \
b1.mtdA(),   b1.mtdB(); \
c1.mtdA(),   c1.mtdB(),   c1.mtdC()
# ('LA_inst(LA_1)',)
# ('LA_inst(LB_1)', 'LB_inst(LB_1)')
# ('LA_inst(LC_1)', 'LB_inst(LC_1)', 'LC_inst(LC_1)')
a1.mtdv(),; \
b1.mtdv(), LA.mtdv(b1); \
c1.mtdv(), LA.mtdv(c1), LB.mtdv(c1)
# ('LA_virt(LA_1)',)
# ('LB_virt(LB_1)', 'LA_virt(LB_1)')
# ('LC_virt(LC_1)', 'LA_virt(LC_1)', 'LB_virt(LC_1)')
# >>>



#Výpis 27.5:	Demonstrace dědění initorů
###########################################################################q
class Matka27:
    def __init__(self, a, b, c): self.t = (a, b, c)
    def __repr__(self): return f"{self.__class__.__name__}{self.t}"

class Dcera27(Matka27): """Dědí initor od rodiče. """

Matka27(1, 2, 3),   Dcera27(10, 20, 30)
# (Matka27(1, 2, 3), Dcera27(10, 20, 30))
Dcera27()
# Traceback (most recent call last):
#   File "<pyshell#29>", line 1, in <module>
#     Dcera27()
# TypeError: Matka27.__init__() missing 3 required positional arguments: 'a', 'b', and 'c'
# >>>



#Výpis 27.6:	Ukázka definice a použití vlastní výjimky
###########################################################################q
class RobotError(Exception):
    """Výjimka vyhazovaná při uvedení robota do chybového stavu.
    Atributy:
        robot -- Robot, který se dostal do chybového stavu
        message -- Popis chybového stavu
    """

    def __init__(self, robot, message):
        self.robot   = robot
        self.message = message

raise RobotError('Karel_1', 'Robot narazil do zdi')
# Traceback (most recent call last):
#   File "<pyshell#25>", line 1, in <module>
#     raise RobotError('Karel_1', 'Robot narazil do zdi')
# RobotError: ('Karel_1', 'Robot narazil do zdi')
# >>>



#Výpis 27.Y:	Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
