#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m28__Násobné_dědění.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
28  Násobné dědění

Co se v kapitole naučíte
Tato kapitola vám vysvětlí, jak v Pythonu využívat násobné dědění a
jaká pravidla při jeho používání platí. Soustředí se přitom především
na pravidla vyhledání deklarovaného atributu v hierarchii předků.
Probere komolení jmen a na závěr představí návrhový vzor Šablonová metoda
a předvede jeho implementaci.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 28.1:	Zdrojový kód tříd z modulu m28a_Diamant demonstrujících
#               chování tříd uspořádaných do diamantové architektury
###########################################################################q

""" Je uloženo v souboru m28a_Diamant.py. """



#Výpis 28.2:	Prověrka vlastností násobného dědění
###########################################################################q
from m28a_Diamant import *
# ===== Modul m28a_Diamant ===== START
# ===== Modul m28a_Diamant ===== STOP
dbg.prSeq(Dcera.__mro__)    # Posloupnost prohledávání předků
# <class 'm28a_Diamant.Dcera'>
# <class 'm28a_Diamant.Matka1'>
# <class 'm28a_Diamant.Matka2'>
# <class 'm28a_Diamant.Babička'>
# <class 'object'>
d = Dcera()
# ==> Dcera.__init__
# |   ==> Matka1.__init__
# |   |   ==> Matka2.__init__
# |   |   |   ==> Babička.__init__
# |   |   |   <== Babička.__init__ - 1
# |   |   <== Matka2.__init__ - 1
# |   <== Matka1.__init__ - 1
# <== Dcera.__init__ - 1
d.__dict__
# {'ID': 1, 'iB': 'insBab', 'iM': 'insMa1', 'iD': 'insDcA'}
d.cM,   Dcera.cM,   Matka1.cM,   Matka2.cM
# ('clsMa1', 'clsMa1', 'clsMa1', 'clsMa2')
# >>>



#Výpis 28.3:	Definice třídy Dcera2 v modulu m28a_Diamant
###########################################################################q

""" Je uloženo v souboru m28a_Diamant.py. """



#Výpis 28.4:	Použití třídy Dcera2
###########################################################################q
dB = Dcera2()
# ==> Dcera2.__init__
# |   ==> Matka1.__init__
# |   |   ==> Matka2.__init__
# |   |   |   ==> Babička.__init__
# |   |   |   <== Babička.__init__ - 2
# |   |   <== Matka2.__init__ - 2
# |   <== Matka1.__init__ - 2
# |   ==> Matka2.__init__
# |   |   ==> Babička.__init__
# |   |   <== Babička.__init__ - 3
# |   <== Matka2.__init__ - 3
# <== Dcera2.__init__ - 3
dB.__dict__
# {'ID': 3, 'iB': 'insBab', 'iM': 'insMa2', 'iD': 'insDc2'}
dB.cM,   Dcera2.cM
# ('clsMa1', 'clsMa1')
# >>>



#Výpis 28.5:	Definice modulu m28b_Argumenty s třídami používajícími
#               násobné dědění a konstruktory s parametry
###########################################################################q

""" Je uloženo v souboru m28b_Argumenty.py. """



#Výpis 28.6:	Průběh inicializace instance třídy DceraA
###########################################################################q
from m28b_Arguments import DceraA
# ===== Modul m28b_Arguments ===== START
# ===== Modul m28b_Arguments ===== STOP
DceraA(arg_b='Bab', arg_m1='Ma1', arg_m2='Ma2', arg_d='Dce')
# ==> DceraA.__init__
# |   arg_d='Dce', kwds={'arg_b': 'Bab', 'arg_m1': 'Ma1', 'arg_m2': 'Ma2'}
# |   ==> MatkaA1.__init__
# |   |   arg_m1='Ma1', kwds={'arg_b': 'Bab', 'arg_m2': 'Ma2'}
# |   |   ==> MatkaA2.__init__
# |   |   |   arg_m2='Ma2', kwds={'arg_b': 'Bab'}
# |   |   |   ==> BabičkaA.__init__
# |   |   |   |   arg_b='Bab', kwds={}
# |   |   |   <== Babička.__init__ - 1
# |   |   <== MatkaA2.__init__ - 1
# |   <== MatkaA1.__init__ - 1
# <== DceraA.__init__ - 1
# DceraA_1
# >>>



#Výpis 28.7:	Nerealizovatelná a následně opravená hierarchie tříd
###########################################################################q
Ba1 = type('BabičkaA1', (),         {})
Ba2 = type('BabičkaA2', (),         {})
Ma1 = type('MatkaA1',   (Ba1, Ba2), {})
Ma2 = type('MatkaA2',   (Ba2, Ba1), {})
Da1 = type('DceraA1',   (Ma1, Ma2), {})
# Traceback (most recent call last):
#   File "<pyshell#15>", line 1, in <module>
#     Da1 = type('DceraA1',   (Ma1, Ma2), {})
# TypeError: Cannot create a consistent method resolution
# order (MRO) for bases BabičkaA1, BabičkaA2
Ma2 = type('MatkaA2',   (Ba1, Ba2), {})
Da1 = type('DceraA1',   (Ma1, Ma2), {})
dbg.prSeq(Da1.__mro__)
# <class '__main__.DceraA1'>
# <class '__main__.MatkaA1'>
# <class '__main__.MatkaA2'>
# <class '__main__.BabičkaA1'>
# <class '__main__.BabičkaA2'>
# <class 'object'>
# >>>



#Výpis 28.8:	Definice složitější hierarchie tříd
###########################################################################q
Bb1 = type('BabičkaB1', (),         {})
Bb2 = type('BabičkaB2', (),         {})
Bb3 = type('BabičkaB3', (),         {})
Mb1 = type('MatkaB1',   (Bb1, Bb2), {})
Mb2 = type('MatkaB2',   (Bb2, Bb3), {})
Db1 = type('DceraB1',   (Mb1, Mb2), {})
dbg.prSeq(Db1.__mro__)
# <class '__main__.DceraB1'>
# <class '__main__.MatkaB1'>
# <class '__main__.BabičkaB1'>
# <class '__main__.MatkaB2'>
# <class '__main__.BabičkaB2'>
# <class '__main__.BabičkaB3'>
# <class 'object'>
# >>>



#Výpis 28.9:	Pseudosoukromý atribut a komolení jmen
###########################################################################q
class Pseudo:
    __atr = 'Pseudosoukromý'
    _atr_ = 'Třídní'
    def puu(): return Pseudo.__atr
    def uau(): return _atr_
    def uua(): return __atr                                         #SYNC

dbg.prDict(Pseudo)
# ##### Atributy objektu: <class '__main__.Pseudo'>
# _Pseudo__atr = Pseudosoukromý
# _atr_ = Třídní
# puu = <function Pseudo.puu at 0x000001E46E04C160>
# uau = <function Pseudo.uau at 0x000001E46E04D7E0>
# uua = <function Pseudo.uua at 0x000001E46E04DB40>
_atr_ = 'Globální';    __atr = 'Neviditelný'
print(f'{Pseudo.puu()=},  {Pseudo.uau()=}')
# Pseudo.puu()='Pseudosoukromý',  Pseudo.uau()='Globální'
Pseudo.uua()
# Traceback (most recent call last):
#   File "<pyshell#37>", line 1, in <module>
#     Pseudo.uua()
#   File "<pyshell#32>", line 6, in uua
#     def uua(): return __atr
# NameError: name '_Pseudo__atr' is not defined
# >>>



#Výpis 28.10:	Definice tříd Bc a Mc v modulu m28c_Komolení
###########################################################################q

""" Je uloženo v souboru m28c_Komolení.py. """



#Výpis 28.11:	Použití tříd Bc a Mc a jejich instancí
###########################################################################q
from m28c_Komolení import *
# ===== Modul m28c_Komolení ===== START
# ===== Modul m28c_Komolení ===== STOP
bc = Bc();   mc = Mc();   bc, mc
# (Bc_1, Mc_2)
mc.tmpl()
# Soukr. v Bc pro Mc_2:
#    self.__cpa='pr cls Bc',   self.cpub='pu cls Mc'
#    self.__ipa='pr ins Bc',   self.ipub='pu ins Mc'
# Metoda v Mc pro Mc_2:
#    self.__cpa='pr cls Mc',   self.cpub='pu cls Mc'
#    self.__ipa='pr ins Mc',   self.ipub='pu ins Mc'
Bc._Bc__count = 10
bc = Bc();   mc = Mc();   bc, mc
# (Bc_11, Mc_12)
# >>>



#Výpis 28.Y:	Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
