#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m33_Generátory_a_iterátory.py
"""
Zadávané příkazy a záznamy odpovědí uvedené ve výpisech kapitoly
33  Iterátory a generátory
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 33.1:	Definice třídy Prime, její instance jsou iterovatelné objekty
#               a současně iterátory
###########################################################################q
class prime():
    """Instance jsou iterátory poskytující postupně prvočísla
    počínaje číslem 2 až do zadané hodnoty.
    """
    def __init__(self, max:int):
        self.max  = max  # Tady končíme
        self.gen  = []   # Seznam nalezených prvočísel
                                                                    #SYNC
    def __iter__(self):
        """Má vrátit iterátor - vrátí sám sebe."""
        return self
                                                                    #SYNC
    def __next__(self) -> int:
        """Vrátí další prvočíslo menší než max.
        """
        last = self.gen[-1] if len(self.gen) > 0 else 1
        # Začnu od prvního většího než poslední nalezené prvočíslo
        while (last := last+1) < self.max:
            for i in range(len(self.gen)):
                if last % self.gen[i] == 0:
                    break   # Je dělitelné
            else: # Nebylo dělitelné žádným předchozím - je to prvočíslo
                self.gen.append(last)   # Přidám je do seznamu nalezených
                return last             # a vrátím jako další hodnotu
        raise StopIteration     # Žádné další menší než max už není
                                                                    #SYNC
print(*prime(99))
# 2 3 5 7 11 13 17 19 23 29 31 37 41 43 47 53 59 61 67 71 73 79 83 89 97
# >>>



#Výpis 33.2:	Generátorový výraz a jeho použití
###########################################################################q
def print_sum_odd(limit:int) -> None:
    """Vytiskne součet čtverců lichých hodnot ze zadaného intervalu."""
    print(  *(i*i for i in range(10) if i%2), sep='+', end=' = ')
    print(sum(i*i for i in range(10) if i%2))

print_sum_odd(10)
# 1+9+25+49+81 = 165
# >>>



#Výpis 33.3:	Nekorektní použití generátorového výrazu
###########################################################################q
generator_expression = (i*i for i in range(10) if i%2)
type(generator_expression)
# <class 'generator'>
print(*generator_expression, sep='+')
# 1+9+25+49+81
sum(generator_expression)
# 0
# >>>



#Výpis 33.4:	Definice a použití generátorové funkce prime_fun()
###########################################################################q
def prime_fun(max:int):
    """Generátorová funkce, jejíž generátor poskytuje postupně prvočísla
    počínaje číslem 2 až do zadané hodnoty.
    """
    max  = max  # Tady končíme
    gen  = []   # Seznam nalezených prvočísel
    last = gen[-1] if len(gen) > 0 else 1
    # Začnu od prvního většího než poslední nalezené prvočíslo
    while (last := last+1) < max:
        for i in range(len(gen)):
            if last % gen[i] == 0:
                break   # Je dělitelné
        else: # Nebylo dělitelné žádným předchozím - je to prvočíslo
            gen.append(last)   # Přidám je do seznamu nalezených
            yield last         # a vrátím jako další hodnotu
                                                                    #SYNC
prime_fun;    (pf99:=prime_fun(99),  pf99.__name__)
# <function prime_fun at 0x000001E401486E60>
# (<generator object prime_fun at 0x000001E40143EFF0>, 'prime_fun')
pf99.__next__(), pf99.__next__(), pf99.__next__(), pf99.__next__()
# (2, 3, 5, 7)
print(*pf99)
# 11 13 17 19 23 29 31 37 41 43 47 53 59 61 67 71 73 79 83 89 97
# >>>



#Výpis 33.5:	Definice generátorové funkce gen1() demonstrující
#               možnost vícenásobného použití příkazu yield
###########################################################################q
def gen1(number):
    """Funkce demonstruje možnost vícenásobného použití příkazu yield
    v těle jedné funkce."""
    yield(f'Start: {number}')   # Tisk výchozí hodnoty argumentu
    for s in ('První', 'Druhý', 'Třetí'):
        yield (f'\n{s}: ')
        for n in range(number, number+3):
            yield n
        number = n      # Přebírá poslední použitou hodnotu
    yield '\nKONEC\n'
                                                                    #SYNC
for x in gen1(17): print(x, end='')
                                                                    #SYNC
# Start: 17
# První: 171819
# Druhý: 192021
# Třetí: 212223
# KONEC
# >>>



#Výpis 33.6:	Demonstrace funkce generátorů
###########################################################################q
def gen_fce():
    """Funkce pro demonstraci fungování generátoru používajícího výraz yield."""
    x = 0; y=7
    while y:
        print(str(x:=x+1) + '. běh: ', end='')
        print(f'Minule: {x=}, {y=}, Nyní:', (y := (yield f'{y*y=}')))
    print('konec')

def pr(x):
    """Pomocná funkce pro kontrolní tisky."""
    print(f'Dodáno: {x},  Obdrženo: {gen_iter.send(x)}')

gen_iter = gen_fce() # Zavolání generátorové funkce vytvoří generátor
type(gen_iter)
# <class 'generator'>
gen_iter.send(99)    # Chyba - žádný yield se ještě nevyhodnocoval
# Traceback (most recent call last):
#   File "<pyshell#24>", line 1, in <module>
#     gen_iter.send(99)    # Chyba - žádný yield se ještě nevyhodnocoval
#   File "<pyshell#19>", line -1, in gen_fce
# TypeError: can't send non-None value to a just-started generator
gen_iter = gen_fce() # Od verze 3.10 se po chybě musí generátor vytvořit znovu
next(gen_iter)       # Tímto se generátor odstartuje
# 1. běh: 'y*y=49'
pr(9)                # Nyní mu již můžeme posílat hodnoty
# Minule: x=1, y=7, Nyní: 9
# 2. běh: Dodáno: 9,  Obdrženo: y*y=81
pr(8)
# Minule: x=2, y=9, Nyní: 8
# 3. běh: Dodáno: 8,  Obdrženo: y*y=64
next(gen_iter)
# Minule: x=3, y=8, Nyní: None
# konec
# Traceback (most recent call last):
#   File "<pyshell#30>", line 1, in <module>
#     next(gen_iter)
# StopIteration
# >>>



#Výpis 33.7:	Definice generátorové funkce ord_gen() pracující s výrazem yield
###########################################################################q
def ord_gen():
    """Definice generátorové funkce schopné průběžně upravovat krok.
    """
    step   = 1   # Proměnná definující přírůstek hodnot parametru cyklu
    result = 1   # Hodnota parametru cyklu předávaná volající funkci
    while True:
        change = yield result   # Zde se činnost přerušuje a opět navazuje
        if not change:          # Normální průběh
            result += step      # Inkrementace parametru cyklu pro příště
        elif change > 0:        # Bude zvětšovat hodnotu přírůstku
            step  *= 10         # Nová velikost přírůstku
            result = step       # Hodnota, kterou budeme nyní vracet
        elif change < 0:        # Bude končit
            yield 'KONEC'       # Před ukončením cyklu musí vrátit hodnotu
            break
        else:
            raise RuntimeError('Špatná hodnota argumentu funkce send()')
    print('Generátor končí')
# ...
# >>>



#Výpis 33.8:	Definice funkce orders() využívající možnost ovlivnit generátor
###########################################################################q
def orders(nums:int, sentinel:int):
    """Tiskne prvních »nums« čísel jednotlivých řádů
    dokud první číslo dalšího řádu nepřesáhne hodnotu »sentinel«.
    """
    rest = nums             # Kolik čísel zbývá vytisknout
    gen_iter = ord_gen()    # Zapamatuje si vytvořený generátor,
    for x in gen_iter:      #            aby jej pak mohl oslovovat
        print(f'{x} - ', end='')    # Standardní činnost v těle cyklu
        if (rest:=rest-1)==0: # Při vytištění zadaného počtu zvětšit přírůstek
            if x < sentinel:  # Ještě jsme nepřetekli
                x   = gen_iter.send(1)      # Žádost o zvětšení kroku cyklu
                print(f'#\n{x} - ', end='') # První hodnota s novým krokem
                rest = nums-1  # -1, protože první jsme právě vytiskli
            else:   # Přeběhli jsme »sentinel«, budeme končit
                x = gen_iter.send(-1)       # x = poslední obdržená hodnota
    print(f'Poslední obdržená hodnota = {x!r}')
                                                                    #SYNC
orders(5, 111)
# 1 - 2 - 3 - 4 - 5 - #
# 10 - 20 - 30 - 40 - 50 - #
# 100 - 200 - 300 - 400 - 500 - Generátor končí
# Poslední obdržená hodnota = 'KONEC'
# >>>



#Výpis 33.9:	AHA-příklad s definicí generátorových funkcí gen2() a gen21()
#               demonstrujících použití výrazů yield a yield from
###########################################################################q
def gen2(x, y):
    """Generátorová funkce využívající výrazy/příkazy yield from
    a postupně vracející první tři mocniny čísel »y« po sobě jdoucích čísel
    počínaje číslem »x«."""
    for n in range(x, x+y):
        print(f'Před:: ', end='')
        yield from gen21(n)     # Předává řízení generátoru gen21
        print (f'Mezi:: ', end='')
        yield '(#)'
        print ('Po::')

def gen21(n):
    """Postupně poskytne první tři mocniny svého argumentu."""
    for x in range (3):
        print(f'({x})', end='')
        yield n
        n *= n
    print('Generátor gen21 končí')

for i in gen2(5, 3): print(i, end='-')

# Před:: (0)5-(1)25-(2)625-Generátor gen21 končí
# Mezi:: (#)-Po::
# Před:: (0)6-(1)36-(2)1296-Generátor gen21 končí
# Mezi:: (#)-Po::
# Před:: (0)7-(1)49-(2)2401-Generátor gen21 končí
# Mezi:: (#)-Po::
# >>>



#Výpis 33.0:	Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
