#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/64_PGM/64_INP/m34__Přetěžování_operátorů.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
34  Přetěžování operátorů.

Co se v kapitole naučíte
Kapitola vás seznámí s možnostmi rozšířit schopnosti instancí vaší třídy
o používání některých zabudovaných operátorů. Vysvětlí, jak se definuje
chování instancí při použití zadaného operátoru a jaké záludnosti
na vás mohou při snaze o implementaci některých z těchto metod čekat.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 34.1:	Využití dekorátoru total_ordering pro doplnění porovnávacích metod
###########################################################################q
from functools import total_ordering
@total_ordering
class Student:
    def __init__(self, firstname, lastname):
        self.firstname = firstname
        self.lastname  = lastname
                                                                    #SYNC
    def _is_valid_operand(self, other):
        return (hasattr(other, "lastname") and
                hasattr(other, "firstname"))
                                                                    #SYNC
    def __eq__(self, other):
        if not self._is_valid_operand(other):
            return NotImplemented
        return ((self.lastname.lower(), self.firstname.lower()) ==
                (other.lastname.lower(), other.firstname.lower()))
                                                                    #SYNC
    def __lt__(self, other):
        if not self._is_valid_operand(other):
            return NotImplemented
        return ((self.lastname.lower(), self.firstname.lower()) <
                (other.lastname.lower(), other.firstname.lower()))

class Object(): """Demonstrační třída"""

sa = Student('A', 'A');    sb = Student('B', 'B')
oa=Object();  oa.firstname=oa.lastname='O'
sa<=sb, sa>oa, sa==oa, sb>=oa, oa<=sb, oa!=oa, oa==oa
# (True, False, False, False, False, False, True)
# >>>



#Výpis 34.2:	Definice třídy Zlomek v modulu m34a_Zlomky
###########################################################################q

""" Je uloženo v souboru m25a_Zlomky.py. """



#Výpis 34.3:	Práce s instancemi třídy Zlomek
###########################################################################q
from m34a_Zlomky import *
# ===== Modul m34a_Zlomky ===== START
# ===== Modul m34a_Zlomky ===== STOP
z63=Zlomek(16,3);  z84=Zlomek(8,4);  z12=Zlomek(1,2);   z63, z84, z12
# (Zlomek(5+1/3), Zlomek(2), Zlomek(1/2))
print(z12, f" -  for:{z12}  -  repr:{z12=}  -  for:{z12=:}")
# (1/2)Zlomek  -  for:(1/2)  -  repr:z12=Zlomek(1/2)  -  for:z12=(1/2)
f"#{z12:=^15}#"
# '#=====(1/2)=====#'
f"#{z12*z63=:*^15}#{z84+z12=:+^15}#"
# '#z12*z63=****(2+2/3)****#z84+z12=++++(2+1/2)++++#'
# >>>



#Výpis 34.4:	Definice třídy Indexer přetěžující operátor []
###########################################################################q
class Indexer:
    def __getitem__(self, index):
        return index ** 2

x = Indexer();   x[3]
# 9
for i in range(5):   print(x[i], end=' - ')

# 0 - 1 - 4 - 9 - 16 -
# >>>



#Výpis 34.5:	Přidání instanční metody pro konkrétní instanci
###########################################################################q
class instancemethod:
    """Převádí běžné funkce na instanční metody zadané instance."""
    def __init__(self, inst, fce):
        self.inst = inst    # Instance, pro níž balím funkci
        self.fce  = fce     # Funkce převáděná na instanční metodu
    def __call__(self, *args, **kwds):
        return self.fce(self.inst, *args, **kwds)

def f1(self):
    """Samostatná metoda prozrazující třídu instance, jíž je přidělena."""
    print(f"Instance třídy {self.__class__.__name__}")

def f2(self, a, b, c):
    """Samostatná metoda, jež bude volat metodu instance, jíž bude přidělena."""
    self.im1()
    print(a, b, c)

class Test: """Pomocná třída, jejíž instanci dodáme metody."""

t = Test()
t.im1 = instancemethod(t, f1)
t.im2 = instancemethod(t, f2)
t.im2(10, 20, 30)
# Instance třídy Test
# 10 20 30
# >>>



#Výpis 34.6:	Demonstrace rozdílů v kódu při použití příkazu with
###########################################################################q
def print0(filename):
    """Vytiskne obsah souboru - verze nepoužívající příkaz with."""
    file = None
    try:
        file = open(filename)
        for line in file:
            print(line)
    except Exception as err:
        print(err)
    finally:
        if file is not None:
            file.close()

def print1(filename):
    """Vytiskne obsah souboru s použitím příkazu with."""
    try:
        with open(filename) as file:
            for line in file:
                print(line)
    except Exception as err:
        print(err)



#Výpis 34.7:	Emulace postupu při zadání příkazu with
###########################################################################q
# Pomocné operace potřebné pro korektní překlad
import sys
BLOCK = ...             # Zastupuje prováděný blok příkazů
EXPR  = open("dbg.py")  # Zastupuje výraz vracející správce kontextu

# Emulovaný kód používající příkaz with
with EXPR as VAR:
    BLOCK

# Kód, který se chová stejně jako výše popsaný příkaz with
mgr   = (EXPR)      # Zapamatuje si zadaného správce kontextu
exit  = type(mgr).__exit__          # Nespouští ji, jen si ji pamatuje
value = type(mgr).__enter__(mgr)    # Spustí metodu a zapamatuje si výsledek
exc   = False       # Předpokládá, že nebude vyvolána výjimka
try:
    try:
        VAR = value  # Jen je-li použita klauzule "as VAR"
        BLOCK
    except:
        # Kdyby BLOCK vyvolal nějakou výjimku
        exc = True      # Byla vyhozena výjimka
        if not exit(mgr, *sys.exc_info()):  # Požadovaná trojice hodnot
            raise       # Má se následně vyvolat
finally:
    # Nejprve se realizují potřebné úklidové akce
    if not exc:   # Neměla-li se vyvolat výjimka ...
        exit(mgr, None, None, None) # korektně se vše ukončí



#Výpis 34.0:	Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
