#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m36__Dekorátory.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
26  Dekorátory.

Co se v kapitole naučíte
Kapitola vás seznámí s dekorátory, naučí vás používat existující dekorátory
a poté také definovat dekorátory vlastní.
Předvede rozdíly mezi dekorováním funkcí a tříd
a na závěr ještě stručně probere některé speciální možnosti.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 36.1:	Ukázka použití třídních metod
###########################################################################q
class Matka36a0:
    počet = 0
    @classmethod
    def další(cls, inc):         cls.počet += inc;   return cls.počet
    def __init__(self, inc=1):   self.ID = self.další(inc)
    def __repr__(self):   return f"{self.__class__.__name__}({self.ID})"

class Dcera36a1(Matka36a0):   # Přebíjí rodičovský initor
    počet = 0
    def __init__(self):   super().__init__(10);   self.ID += 1

class Dcera36a2(Matka36a0):   # Zdědí rodičovský initor
    počet = 0

Matka36a0(), Dcera36a1(), Dcera36a2(100)
# (Matka36a0(1), Dcera36a1(11), Dcera36a2(100))
Matka36a0(), Dcera36a1(), Dcera36a2(100)
# (Matka36a0(2), Dcera36a1(21), Dcera36a2(200))
Matka36a0(), Dcera36a1(), Dcera36a2(100)
# (Matka36a0(3), Dcera36a1(31), Dcera36a2(300))
# >>>



#Výpis 36.2:	Ukázka definice jednoduché tovární metody
###########################################################################q
class Osoba:
    def __init__(self, křestní=None, příjmení=None):
        """Initor volaný standardním konstruktorem."""
        self.křestní  = křestní
        self.příjmení = příjmení
        self.další    = ''
                                                                    #SYNC
    @classmethod
    def jméno(cls, jméno:str, **další):
        """Tovární metoda pro alternativní argumenty."""
        slova = jméno.split()
        return cls(' '.join(slova[:-1]), slova[-1], **další)
                                                                    #SYNC
    def __repr__(self):
        křestní  = self.křestní
        příjmení = self.příjmení
        return (f'{self.__class__.__name__}('
                f'{křestní=}, {příjmení=}{self.další})')

class Postava(Osoba):
    def __init__(self, křestní=None, příjmení=None, obor:str=''):
        super().__init__(křestní, příjmení)
        self.obor  = obor
        self.další = f', {obor=}'

Osoba('Tomáš', 'Marný')
# Osoba(křestní='Tomáš', příjmení='Marný')
Osoba.jméno('Jana Vdaná')
# Osoba(křestní='Jana', příjmení='Vdaná')
Postava.jméno('Ilja Muromec', obor='Hrdina')
# Postava(křestní='Ilja', příjmení='Muromec', obor='Hrdina')
Postava.jméno('Josef Václav Sládek', obor='Básník')
# Postava(křestní='Josef Václav', příjmení='Sládek', obor='Básník')
# >>>



#Výpis 36.3:	Definice dekorátoru – třídy traced v modulu m36a_Traced
###########################################################################q

""" Je uloženo v souboru
m36a_Traced.py
"""



#Výpis 36.4:	Použití dekorátoru traced
###########################################################################q
from m36a_Traced import traced
# ===== Modul m36a_Traced ===== START
# ===== Modul m36a_Traced ===== STOP
@traced
def test(n):
    import m36b_Fact as mf
    mf.factR = traced(mf.factR)
    mf.factR(n)

test(3)
# >> test((3,))
# ===== Modul m36b_Fact ===== START
# ===== Modul m36b_Fact ===== STOP
#    >> factR((3,))
#       >> factR((2,))
#          >> factR((1,))
#          << factR=1
#       << factR=2
#    << factR=6
# << test=None
test(1)
# >> test((1,))
# fce=<m36a_Traced.traced object at 0x000001ADAC4B5900>
#    >> factR((1,))
#    << factR=1
# << test=None
test
# <m36a_Traced.traced object at 0x000001ADAC4B4E80>
# >>>



#Výpis 36.5:	Definice dekorátorů jedináčka v modulu m36c_Singleton
###########################################################################q

""" Je uloženo v souboru m36b_Singleton.py. """



#Výpis 36.7:	Použití dekorátoru singleton
###########################################################################q
from m36c_Singleton import *
@singleton
class STest:
    count = 0
    def __init__(self):
        # STest.count+=1
        # self.ID=f'STest_{STest.count}'
        self.__class__.count += 1
        self.ID = f'STest_{self.__class__.count}'
    def __repr__(self):   return self.ID

STest(), STest(), STest()
# (STest_1, STest_1, STest_1)
# >>>



#Výpis 36.8:	Definice datové třídy a její test
###########################################################################q
from dataclasses import dataclass
from typing      import ClassVar
# >>> \
@dataclass
class Položka:
    """Instance reprezentují položky na skladě."""
    název:    str
    cena:     float
    množství: int = 0
    pořadí:   ClassVar[int] = 0
                                                                    #SYNC
    def __post_init__(self):
        Položka.pořadí += 1
        self.ID = Položka.pořadí
                                                                    #SYNC
    def celkem(self) -> float:
        """Vrátí cenu uskladněných odpovídajících výrobků."""
        return self.cena * self.množství

dbg.prDict(Položka)
# ##### Atributy objektu: <class '__main__.Položka'>
# množství = 0
# pořadí = 0
# celkem = <function Položka.celkem at 0x0000021B035D0280>
dbg.prDict(p := Položka("Máslo", 29, 5))
# ##### Atributy objektu: Položka(název='Máslo', cena=29, množství=5)
# název = Máslo
# cena = 29
# množství = 5
# ID = 1
# >>>



#Výpis 36.0:	Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
