#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m37__Přístup_k_atributům.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
37  Deskriptory, vlastnosti a sloty.

Co se v kapitole naučíte
Tato kapitola představí deskriptory a vlastnosti. Probere možnosti
jejich zadání a použití a upozorní na některá jejich specifika.
Poté naznačí, jak se rozhodovat, kterému z probraných způsobů přístupu
k atributům dát v dané situaci přednost.
Na závěr ještě představí sloty, jako další způsob definice atributů.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 37.1:	Ekvivalent definice vestavěné třídy property v modulu m37a_Property
###########################################################################q

""" Je uloženo v souboru
m37a_Property.py
"""



#Výpis 37.2:	Definice třídy descriptor
###########################################################################q
class descriptor:
    """Datový deskriptor průběžně zaznamenávající jednotlivé přístupy."""
                                                                    #SYNC
    def __init__(self, initval=None):
        self.initval = initval
        print(f'Vytvořen deskriptor s výchozí hodnotou «{initval}»')
                                                                    #SYNC
    def __set_name__(self, owner, name):
        self. name = name
        self._name = '_' + name
        print(f'Název: veřejný={self.name!r}, soukromý={self._name!r}, '
              f'vlastník: {owner}')
                                                                    #SYNC
    def __get__(self, instance, owner):
        val = getattr(instance, self._name, self.initval)
        print(f'Čtení: atribut {self.name} objektu {instance} '
              f'typu {owner} = {val}')
        return val
                                                                    #SYNC
    def __set__(self, instance, val):
        print(f"Zápis: atribut {self.name} objektu {instance} = {val}")
        setattr(instance, self._name, val)
                                                                    #SYNC
    def __repr__(self):
        return f'Deskriptor({self.name})'

# >>>



#Výpis 37.3:	Hrátky s deskriptorem
###########################################################################q
class C37a:
    a1 = descriptor('První')
    a2 = descriptor('Druhý')
    def __init__(self, id):   self.id=id;   print(f'Vytvořen objekt s {id=}')
    def __repr__(self):   return 'C37a_' + str(self.id)
    print('Třída C37a definována')

# Vytvořen deskriptor s výchozí hodnotou «První»
# Vytvořen deskriptor s výchozí hodnotou «Druhý»
# Třída C37a definována
# Název: veřejný='a1', soukromý='_a1', vlastník: <class '__main__.C37a'>
# Název: veřejný='a2', soukromý='_a2', vlastník: <class '__main__.C37a'>
c1 = C37a(1);   c2 = C37a(2);   print(f'{C37a.a1=}, {c1.a1=}, {c2.a1=}')
# Vytvořen objekt s id=1
# Vytvořen objekt s id=2
# Čtení: atribut a1 objektu None typu <class '__main__.C37a'> = První
# Čtení: atribut a1 objektu C37a_1 typu <class '__main__.C37a'> = První
# Čtení: atribut a1 objektu C37a_2 typu <class '__main__.C37a'> = První
# C37a.a1='První', c1.a1='První', c2.a1='První'
c1.a1='C1';   c2.a1='C2';   print(f'{C37a.a1=}, {c1.a1=}, {c2.a1=}, {c1.a2=}, {c2.a2=}')
# Zápis: atribut a1 objektu C37a_1 = C1
# Zápis: atribut a1 objektu C37a_2 = C2
# Čtení: atribut a1 objektu None typu <class '__main__.C37a'> = První
# Čtení: atribut a1 objektu C37a_1 typu <class '__main__.C37a'> = C1
# Čtení: atribut a1 objektu C37a_2 typu <class '__main__.C37a'> = C2
# Čtení: atribut a2 objektu C37a_1 typu <class '__main__.C37a'> = Druhý
# Čtení: atribut a2 objektu C37a_2 typu <class '__main__.C37a'> = Druhý
# C37a.a1='První', c1.a1='C1', c2.a1='C2', c1.a2='Druhý', c2.a2='Druhý'
vars(c1), vars(c2)
# ({'id': 1, '_a1': 'C1'}, {'id': 2, '_a1': 'C2'})
C37a.a1='Třídní';   C37a.a1, c1.a1, c2.a1, c1.a2, c2.a2
# Čtení: atribut a2 objektu C37a_1 typu <class '__main__.C37a'> = Druhý
# Čtení: atribut a2 objektu C37a_2 typu <class '__main__.C37a'> = Druhý
# ('Třídní', 'Třídní', 'Třídní', 'Druhý', 'Druhý')
import dbg;   dbg.prDict(C37a)
# ##### Atributy objektu: <class '__main__.C37a'>
# a1 = Třídní
# a2 = Deskriptor(a2)
# >>>



#Výpis 37.4:	Postup metody __getattribute__() při vyhodnocování atributu instance
###########################################################################q
def object_getattribute(obj, name):
    """Emuluje metodu PyObject_GenericGetAttr() definovanou v Objects/object.c
    a zjišťující hodnotu atributu s názvem »name« objektu »obj«."""
    null = object()         # Indikátor nenalezeného objektu
    objtype = type(obj)     # Typ oslovovaného objektu
    # Pokus o získání třídního atributu s daným názvem
    cls_var = getattr(objtype, name, null)
    # Pokus o získání metody »__get__()« tohoto atributu
    descr_get = getattr(type(cls_var), '__get__', null)

    # Atribut má definovanou metodu __get__() => je to deskriptor
    if descr_get is not null:    # Je datový? = má definovanou i metodu
        if (hasattr(type(cls_var), '__set__')       #  __set__()
            or hasattr(type(cls_var), '__delete__') # nebo __delete__()?
        ):  # ANO => je to datový deskriptor -> zavolá jeho metodu
            # __get__(), předá ji oslovovanou instanci a její třídu
            # jako argumenty a vrátí získanou hodnotu
            return descr_get(cls_var, obj, objtype)

    # Není to datový deskriptor => podívá se, má-li instance zadaný atribut
    if hasattr(obj, '__dict__') and name in vars(obj):
        return vars(obj)[name]      # Má jej => vrátí jeho hodnotu

    # Nemá jej => podívá se, má-li metodu __get__()
    if descr_get is not null:
        # Má ji => je to nedatový deskriptor => zavolá ji a vrátí
        return descr_get(cls_var, obj, objtype)      # obdrženou hodnotu

    if cls_var is not null: # Je to alespoň třídní atribut?
        return cls_var      # Je => vrátí jeho hodnotu

    # Nebyl to ani datový deskriptor, ani atribut instance,
    # ani nedatový deskriptor, ani atribut třídy => je to chybné zadání
    raise AttributeError(name)



#Výpis 37.5:	Deskriptor pro odložené vyhodnocení
###########################################################################q
class reify(object):
    """Instance třídy jsou nedatové deskriptory
    podporující odložené vyhodnocení.
    """
    def __init__(self, wrapped):
        """Argumentem je inicializační funkce/metoda daného atributu."""
        self.wrapped = wrapped
                                                                    #SYNC
    def __get__(self, inst, objtype=None):
        if inst is None:    # Ptají se na atribut třídy ->
            return self     #       deskriptor vrátí sám sebe
        # Ptají se na atribut instance -> spustí se inicializační metoda
        val = self.wrapped(inst)
        # Hodnotu zadá jako atribut instance. Její získání má přednost
        # před aktivací nedatového atributu, takže metoda už nebude
        # pro danou instanci volána, ledaže by byl atribut odstraněn
        setattr(inst, self.wrapped.__name__, val)
        return val

class C37b:
    """Třída pro test odloženého vyhodnocení."""
    def __init__(self):
        print(f'Instance definována s atributy {vars(self)}')
                                                                    #SYNC
    @reify
    def attr(self):
        print('Počítám hodnotu atributu...')
        return 'Spočteno'

cb = C37b()
# Instance definována s atributy {}
dbg.prDict(C37b)
# ##### Atributy objektu: <class '__main__.C37b'>
# attr = <__main__.reify object at 0x000002050B53EA10>
cb.attr;   vars(cb)
# Počítám hodnotu atributu...
# 'Spočteno'
# {'attr': 'Spočteno'}
cb.attr, cb.attr
# ('Spočteno', 'Spočteno')
# >>>



#Výpis 37.6:	Definice třídy C37c v modulu m37c_Atributy
###########################################################################q

""" Je uloženo v souboru
R:/71_INP/m37c_Atributy.py
"""



#Výpis 37.7:	Ukázky reakcí na přístup k atributům ve třídě C37c
###########################################################################q
from m37c_Atributy import *
# ===== Modul m34b_Atributy ===== START
# ===== Modul m34b_Atributy ===== STOP
C37c.ca
# 'Class attr'
C37c.cb
# Traceback (most recent call last):
#   File "<pyshell#29>", line 1, in <module>
#     C37c.cb
# AttributeError: type object 'C37c' has no attribute 'cb'
c = C37c()
# __setattr__(self, name='ia', value='Inst attr')
# __getattribute__(self, name='__dict__')
# Spouštím: object.__getattribute__(self, name='__dict__')
# Následující kód bude vypadat divně - čtěte doprovodný text
# >>> __getattribute__(self, name='__dict__')
# Spouštím: object.__getattribute__(self, name='__dict__')
# __getattribute__(self, name='__class__')
# Spouštím: object.__getattribute__(self, name='__class__')
c.ca
# __getattribute__(self, name='ca')
# ca - atributy začínající 'c' jsou třídní =>
#      Volám C37c.__getattribute__(C37c, ca)
# 'Class attr'
c.ia
# __getattribute__(self, name='ia')
# Spouštím: object.__getattribute__(self, name='ia')
# 'Inst attr'
c.ib
# __getattribute__(self, name='ib')
# 'ib - Spočtený v _getattribute__()'
c.ic
# __getattribute__(self, name='ic')
# Spouštím: object.__getattribute__(self, name='ic')
# __getattr__(self, name='ic')
# 'ic - Spočtený v _getattr__()'
c.mtd()
# __getattribute__(self, name='mtd')
# Spouštím: object.__getattribute__(self, name='mtd')
# mtd - Instanční metoda třídy C37c
c.ia='Nová hodnota c.ia';   c.ia
# __setattr__(self, name='ia', value='Nová hodnota c.ia')
# __getattribute__(self, name='__dict__')
# Spouštím: object.__getattribute__(self, name='__dict__')
# __getattribute__(self, name='ia')
# Spouštím: object.__getattribute__(self, name='ia')
# 'Nová hodnota c.ia'
# >>>



#Výpis 37.8:	Definice třídy C37d v modulu m37c_Atributy
###########################################################################q

""" Je uloženo v souboru
R:/71_INP/m37c_Atributy.py
"""



#Výpis 37.9:	Práce s atributy instancí třídy C37d
###########################################################################q
cb = C37d()
cb.ix
# __getattr__(self, name='ix')
# 'Neexistující atribut: ix'
cb.const = 'Konstanta'
# __setattr__(self, name='const', value='Konstanta')
cb.const
# 'Konstanta'
cb.const = 'Změna'
# __setattr__(self, name='const', value='Změna')
# Traceback (most recent call last):
#   File "<pyshell#8>", line 1, in <module>
#     cb.const = 'Změna'
#   File "R:\71_INP\m37c_Atributy.py", line 57, in __setattr__
#     raise ValueError("Hodnotu konstanty nelze měnit")
# ValueError: Hodnotu konstanty nelze měnit
del(cb.const)
# Traceback (most recent call last):
#   File "<pyshell#9>", line 1, in <module>
#     del(cb.const)
#   File "R:\71_INP\m37c_Atributy.py", line 62, in __delattr__
#     raise ValueError(f"Konstantu {name} nelze smazat")
# ValueError: Konstantu const nelze smazat
# >>>



#Výpis 37.10:	Definice modulu m37d_ModuleProperty s vlastní mateřskou třídou
###########################################################################q

""" Je uloženo v souboru
R:/71_INP/m37d_ModuleProperty.py
"""



#Výpis 37.11:	Import modulu m37d_ModuleProperty a práce s jeho vlastností
###########################################################################q
import m37d_ModuleProperty as m37d
# ===== Modul m37d_ModuleProperty ===== START
# ===== Modul m37d_ModuleProperty ===== STOP
m37d.count;  m37d.count;  m37d.count
# '1. přístup k vlastnosti count modulu m37d_ModuleProperty'
# '2. přístup k vlastnosti count modulu m37d_ModuleProperty'
# '3. přístup k vlastnosti count modulu m37d_ModuleProperty'
m37d.count = 0
# Traceback (most recent call last):
#   File "<stdin>", line 1, in <module>
# AttributeError: can't set attribute 'count'
# >>>



#Výpis 37.12:	Ukázka používání slotů
###########################################################################q
class Point:
    __slots__ = ("x", "y")
                                                                    #SYNC
    def __init__(self, x=0, y=0):
        self.x = x
        self.y = y
                                                                    #SYNC
    def __repr__(self):
        return f"Point(x={self.x}, y={self.y})"

p = Point(1, 2);   p
# Point(x=1, y=2)
p.x = 3;   p
# Point(x=3, y=2)
p.z = 4
# Traceback (most recent call last):
#   File "<pyshell#33>", line 1, in <module>
#     p.z = 4
# AttributeError: 'Point' object has no attribute 'z'
# >>>



#Výpis 37.0:	Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
