#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/64_PGM/64_INP/m38__Metatřídy.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
29  Ovlivnění tvorby tříd, metatřídy.

Co se v kapitole naučíte
Kapitola vás seznámí s metatřídami, což jsou objekty umožňující ovlivnit
způsob, jak budou definovány třídy. Nejprve předvede,
jak se prostřednictvím metatřídy definují abstraktní třídy.
Pak vysvětlí, jak může rodičovská třída ovlivnit vytváření svých potomků,
a na závěr vás naučí vytvářet vlastní metatřídy různých druhů.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 38.1:	Použití metody __init_subclass__()
###########################################################################q
class C38a:
    """Třída ovlivňující definice svých potomků."""
    _podtříd = 0
    def __init_subclass__(cls, **kwds):
        super().__init_subclass__(**kwds)
        C38a._podtříd += 1    # Inkrementuje počet vytvořených potomků
        cls._instancí =  0    # Definuje třídní atribut potomka
        cls.cid = C38a._podtříd   # Potomek si pamatuje své rodné číslo
        cls.__repr__ = lambda self: f'{cls.__name__}({self.id})'
    def __init__(self):
        # Inkrementuje počet vytvořených instancí potomka
        self.__class__._instancí += 1
        # Definuje rodné číslo instance potomka
        self.id = f'{self.cid}-{self._instancí}'

class C38A1(C38a):
    def __init__(self):
        super(C38A1, self).__init__()

class C38A2(C38a):
    def __init__(self):
        super().__init__()

C38A1(),   C38A1(),   C38A2(),   C38A1(),   C38A2()
# (C38A1(1-1), C38A1(1-2), C38A2(2-1), C38A1(1-3), C38A2(2-2))
# >>>



#Výpis 38.2:	Šablona testu funkce metatřídy v modulu m38a_TestMetaXxx
###########################################################################q

""" Je uloženo v souboru 
m38a_TestMetaXxx.py 
"""



#Výpis 38.3:	Import modulu m38a_TestMetaXxx
###########################################################################q
import m38a_TestMetaXxx
# ===== Modul m38a_TestMetaXxx ===== START
# ===== Vytvářím třídu =====
# Tělo definované třídy Dcera38Xxx spuštěno:
# Tělo definované třídy Dcera38Xxx ukončeno
# ===== Vytvářím instanci =====
# dx.data='Xxx', dx.mtd(1)='Xxx(1)'
# type(Dcera38Xxx)=<class 'type'>
# ===== Modul m38a_TestMetaXxx ===== STOP
# >>>



#Výpis 38.4:	Definice metatřídy MetaFce definované jako funkce v modulu m38b_MetaFce
###########################################################################q

""" Je uloženo v souboru 
m38b_MetaFce.py. 
"""



#Výpis 38.5:	Import modulu m38b_MetaFce
###########################################################################q
import m38b_MetaFce
# ===== Modul m38b_MetaFce ===== START
# ===== Vytvářím třídu =====
# MetaFce.__prepare__:
# ...classname='Dcera38Fce'
# ...supers=(<class 'm38b_MetaFce.Matka38Fce'>,)
# ...Vracím slovník DICT={'da': 'MF', 'fa': <function __prepare__.<locals>.<lambda> at 0x000002A269844820>}
# Tělo definované třídy Dcera38Fce spuštěno:
# Tělo definované třídy Dcera38Fce ukončeno
# MetaFce:
# ...classname='Dcera38Fce'
# ...supers=(<class 'm38b_MetaFce.Matka38Fce'>,)
# ...['da', 'fa', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ...Vytvořena a inicializována třída <class 'm38b_MetaFce.Dcera38Fce'>
# ===== Vytvářím instanci =====
# df.data='Fce', df.mtd(1)='Fce(1)', df.da='MF'
# df.fa()='<m38b_MetaFce.Dcera38Fce object at 0x00000237C0EF1750>'
# type(Dcera38Fce)=<class 'type'>
# ===== Modul m38b_MetaFce ===== STOP
# >>>



#Výpis 38.6:	Definice metatřídy MetaCls definované jako třída v modulu m38c_MetaCls
###########################################################################q

""" Je uloženo v souboru 
m38c_MetaCls.py. 
"""



#Výpis 38.7:	Import modulu m38c_MetaCls
###########################################################################q
import m38c_MetaCls
# ===== Modul m38c_MetaCls ===== START
# ===== Vytvářím třídu =====
# MetaCls.__prepare__:
# ...classname='Dcera38Cls'
# ...supers=(<class 'm38c_MetaCls.Matka38Cls'>,)
# ...Vracím slovník DICT={'da': 'MC', 'fa': <function MetaCls.__prepare__.<locals>.<lambda> at 0x0000027B6B988790>}
# Tělo definované třídy Dcera38Cls spuštěno:
# Tělo definované třídy Dcera38Cls ukončeno
# MetaCls.__new__:
# ...meta=<class 'm38c_MetaCls.MetaCls'>
# ...classname='Dcera38Cls'
# ...supers=(<class 'm38c_MetaCls.Matka38Cls'>,)
# ...['da', 'fa', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ...Vytvořena třída <class 'm38c_MetaCls.Dcera38Cls'>
# MetaCls.__init__:
# ...classname='Dcera38Cls'
# ...supers=(<class 'm38c_MetaCls.Matka38Cls'>,)
# ...['da', 'fa', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ...Inicializována třída <class 'm38c_MetaCls.Dcera38Cls'>
# ===== Vytvářím instanci =====
# dc.data='Cls', dc.mtd(1)='Cls(1)', dc.da='MC'
# dc.fa()='<m38c_MetaCls.Dcera38Cls object at 0x0000027B6B979CC0>'
# type(Dcera38Cls)=<class 'm38c_MetaCls.MetaCls'>
# ===== Modul m38c_MetaCls ===== STOP
# >>>



#Výpis 38.8:	Definice metatřídy MetaObj definované v modulu m38d_MetaObj jako objekt
###########################################################################q

""" Je uloženo v souboru 
m38d_MetaObj.py. 
"""



#Výpis 38.9:	Import modulu m38d_MetaObj
###########################################################################q
import m38d_MetaObj
# ===== Modul m38d_MetaObj ===== START
# ===== Vytvářím třídu =====
# MetaObj.__prepare__:
# ...self=<m38d_MetaObj.MetaObj object at 0x00000237C0EFC9A0>
# ...classname='Dcera38Obj'
# ...supers=(<class 'm38d_MetaObj.Matka38Obj'>,)
# ...Vracím slovník DICT={'da': 'MF', 'fa': <function MetaObj.__prepare__.<locals>.<lambda> at 0x00000237C0F00280>}
# Tělo definované třídy Dcera38Obj spuštěno:
# Tělo definované třídy Dcera38Obj ukončeno
# MetaObj.__call__:
# ...self=<m38d_MetaObj.MetaObj object at 0x00000237C0EFC9A0>
# ...classname='Dcera38Obj'
# ...supers=(<class 'm38d_MetaObj.Matka38Obj'>,)
# ...['da', 'fa', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ...MetaObj.__new__:
# ......self=<m38d_MetaObj.MetaObj object at 0x00000237C0EFC9A0>
# ......classname='Dcera38Obj'
# ......supers=(<class 'm38d_MetaObj.Matka38Obj'>,)
# ......['da', 'fa', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ......Vytvořena třída CLASS=<class 'm38d_MetaObj.Dcera38Obj'>
# ...MetaObj.__init__:
# ......self=<m38d_MetaObj.MetaObj object at 0x00000237C0EFC9A0>
# ......classname='Dcera38Obj'
# ......supers=(<class 'm38d_MetaObj.Matka38Obj'>,)
# ......['da', 'fa', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ......Inicializována třída CLASS=<class 'm38d_MetaObj.Dcera38Obj'>
# Konec práce MetaObj.call
# ===== Vytvářím instanci =====
# do.data='Cls', do.mtd(1)='Cls(1)', do.da='MF'
# do.fa()='<m38d_MetaObj.Dcera38Obj object at 0x00000237C0EFC9A0>'
# type(Dcera38Obj)=<class 'type'>
# ===== Modul m38d_MetaObj ===== STOP
# >>>



#Výpis 38.10:	Definice jedináčka pomocí __new__()
###########################################################################q
class Singleton38new:
    __instance = None
    def __new__ (cls) :
        if(cls.__instance == None) :
            cls.__instance = object.__new__(cls)
        return cls. __instance
    def __init__(self):
        print(f'Volána metoda __init__()')

print(s1:=Singleton38new(), s2:=Singleton38new(), s1 is s2, sep= '\n')
# Volána metoda __init__()
# Volána metoda __init__()
# <__main__.Singleton38new object at 0x00000237C0EFCFA0>
# <__main__.Singleton38new object at 0x00000237C0EFCFA0>
# True
# >>>



#Výpis 38.12:	Definice jedináčka pomocí metatřídy
###########################################################################q
class MetaSingleton(type):
    __instance = None
    def  __call__(self):
        if (self.__instance == None):
            self.__instance = self.__new__(self)
            self.__init__(self.__instance)
        return self.__instance

class Singleton(metaclass=MetaSingleton):
    def  __init__(self):
        print(f'Volána metoda __init__()')

print(s1 := Singleton(), s2 := Singleton(), s1 is s2, sep='\n')
# Volána metoda __init__()
# <__main__.Singleton object at 0x00000237C0EFC0A0>
# <__main__.Singleton object at 0x00000237C0EFC0A0>
# True
# >>>



#Výpis 38.0:	Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
